/*     */ package org.hibernate.cfg;
/*     */ 
/*     */ import javax.persistence.Column;
/*     */ import javax.persistence.JoinColumn;
/*     */ import javax.persistence.JoinTable;
/*     */ import org.hibernate.AnnotationException;
/*     */ import org.hibernate.mapping.Component;
/*     */ import org.hibernate.mapping.Join;
/*     */ import org.hibernate.mapping.KeyValue;
/*     */ import org.hibernate.mapping.PersistentClass;
/*     */ import org.hibernate.mapping.Property;
/*     */ import org.hibernate.mapping.Table;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ComponentPropertyHolder
/*     */   extends AbstractPropertyHolder
/*     */ {
/*     */   private Component component;
/*     */   
/*     */   public String getEntityName()
/*     */   {
/*  27 */     return this.component.getComponentClassName();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void addProperty(Property prop, Ejb3Column[] columns)
/*     */   {
/*  37 */     Table table = columns[0].getTable();
/*  38 */     if (!table.equals(this.component.getTable())) {
/*  39 */       if (this.component.getPropertySpan() == 0) {
/*  40 */         this.component.setTable(table);
/*     */       }
/*     */       else {
/*  43 */         throw new AnnotationException("A component cannot hold properties split into 2 different tables: " + getPath());
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*  49 */     addProperty(prop);
/*     */   }
/*     */   
/*     */   public Join addJoin(JoinTable joinTableAnn, boolean noDelayInPkColumnCreation) {
/*  53 */     return this.parent.addJoin(joinTableAnn, noDelayInPkColumnCreation);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public ComponentPropertyHolder(Component component, String path, PropertyData inferredData, PropertyHolder parent, ExtendedMappings mappings)
/*     */   {
/*  61 */     super(path, parent, inferredData.getPropertyClass(), mappings);
/*  62 */     setCurrentProperty(inferredData.getProperty());
/*  63 */     this.component = component;
/*     */   }
/*     */   
/*     */   public String getClassName() {
/*  67 */     return this.component.getComponentClassName();
/*     */   }
/*     */   
/*     */   public String getEntityOwnerClassName() {
/*  71 */     return this.component.getOwner().getClassName();
/*     */   }
/*     */   
/*     */   public Table getTable() {
/*  75 */     return this.component.getTable();
/*     */   }
/*     */   
/*     */   public void addProperty(Property prop) {
/*  79 */     this.component.addProperty(prop);
/*     */   }
/*     */   
/*     */   public KeyValue getIdentifier() {
/*  83 */     return this.component.getOwner().getIdentifier();
/*     */   }
/*     */   
/*     */   public PersistentClass getPersistentClass() {
/*  87 */     return this.component.getOwner();
/*     */   }
/*     */   
/*     */   public boolean isComponent() {
/*  91 */     return true;
/*     */   }
/*     */   
/*     */   public boolean isEntity() {
/*  95 */     return false;
/*     */   }
/*     */   
/*     */   public void setParentProperty(String parentProperty) {
/*  99 */     this.component.setParentProperty(parentProperty);
/*     */   }
/*     */   
/*     */ 
/*     */   public Column[] getOverriddenColumn(String propertyName)
/*     */   {
/* 105 */     Column[] result = super.getOverriddenColumn(propertyName);
/* 106 */     if (result == null) {
/* 107 */       String userPropertyName = extractUserPropertyName("id", propertyName);
/* 108 */       if (userPropertyName != null) result = super.getOverriddenColumn(userPropertyName);
/*     */     }
/* 110 */     if (result == null) {
/* 111 */       String userPropertyName = extractUserPropertyName("_identifierMapper", propertyName);
/* 112 */       if (userPropertyName != null) result = super.getOverriddenColumn(userPropertyName);
/*     */     }
/* 114 */     return result;
/*     */   }
/*     */   
/*     */   private String extractUserPropertyName(String redundantString, String propertyName) {
/* 118 */     String result = null;
/* 119 */     String className = this.component.getOwner().getClassName();
/* 120 */     if ((propertyName.startsWith(className)) && (propertyName.length() > className.length() + 2 + redundantString.length()) && (propertyName.substring(className.length() + 1, className.length() + 1 + redundantString.length()).equals(redundantString)))
/*     */     {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 127 */       result = className + propertyName.substring(className.length() + 1 + redundantString.length());
/*     */     }
/* 129 */     return result;
/*     */   }
/*     */   
/*     */   public JoinColumn[] getOverriddenJoinColumn(String propertyName)
/*     */   {
/* 134 */     return super.getOverriddenJoinColumn(propertyName);
/*     */   }
/*     */ }


/* Location:              C:\Users\anandkum\Desktop\source\hibernate-annotations-3.3.1.GA.jar!\org\hibernate\cfg\ComponentPropertyHolder.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */