/*      */ package org.hibernate.cfg.annotations.reflection;
/*      */ 
/*      */ import java.beans.Introspector;
/*      */ import java.lang.annotation.Annotation;
/*      */ import java.lang.reflect.AccessibleObject;
/*      */ import java.lang.reflect.AnnotatedElement;
/*      */ import java.lang.reflect.Field;
/*      */ import java.lang.reflect.Method;
/*      */ import java.util.ArrayList;
/*      */ import java.util.HashMap;
/*      */ import java.util.HashSet;
/*      */ import java.util.Iterator;
/*      */ import java.util.List;
/*      */ import java.util.Map;
/*      */ import java.util.Set;
/*      */ import javax.persistence.AssociationOverride;
/*      */ import javax.persistence.AssociationOverrides;
/*      */ import javax.persistence.AttributeOverride;
/*      */ import javax.persistence.AttributeOverrides;
/*      */ import javax.persistence.Basic;
/*      */ import javax.persistence.CascadeType;
/*      */ import javax.persistence.Column;
/*      */ import javax.persistence.ColumnResult;
/*      */ import javax.persistence.DiscriminatorColumn;
/*      */ import javax.persistence.DiscriminatorType;
/*      */ import javax.persistence.DiscriminatorValue;
/*      */ import javax.persistence.Embeddable;
/*      */ import javax.persistence.Embedded;
/*      */ import javax.persistence.EmbeddedId;
/*      */ import javax.persistence.Entity;
/*      */ import javax.persistence.EntityListeners;
/*      */ import javax.persistence.EntityResult;
/*      */ import javax.persistence.EnumType;
/*      */ import javax.persistence.Enumerated;
/*      */ import javax.persistence.ExcludeDefaultListeners;
/*      */ import javax.persistence.ExcludeSuperclassListeners;
/*      */ import javax.persistence.FetchType;
/*      */ import javax.persistence.FieldResult;
/*      */ import javax.persistence.GeneratedValue;
/*      */ import javax.persistence.GenerationType;
/*      */ import javax.persistence.Id;
/*      */ import javax.persistence.IdClass;
/*      */ import javax.persistence.Inheritance;
/*      */ import javax.persistence.InheritanceType;
/*      */ import javax.persistence.JoinColumn;
/*      */ import javax.persistence.JoinColumns;
/*      */ import javax.persistence.JoinTable;
/*      */ import javax.persistence.Lob;
/*      */ import javax.persistence.ManyToMany;
/*      */ import javax.persistence.ManyToOne;
/*      */ import javax.persistence.MapKey;
/*      */ import javax.persistence.MappedSuperclass;
/*      */ import javax.persistence.NamedNativeQueries;
/*      */ import javax.persistence.NamedNativeQuery;
/*      */ import javax.persistence.NamedQueries;
/*      */ import javax.persistence.NamedQuery;
/*      */ import javax.persistence.OneToMany;
/*      */ import javax.persistence.OneToOne;
/*      */ import javax.persistence.OrderBy;
/*      */ import javax.persistence.PostLoad;
/*      */ import javax.persistence.PostPersist;
/*      */ import javax.persistence.PostRemove;
/*      */ import javax.persistence.PostUpdate;
/*      */ import javax.persistence.PrePersist;
/*      */ import javax.persistence.PreRemove;
/*      */ import javax.persistence.PreUpdate;
/*      */ import javax.persistence.PrimaryKeyJoinColumn;
/*      */ import javax.persistence.PrimaryKeyJoinColumns;
/*      */ import javax.persistence.QueryHint;
/*      */ import javax.persistence.SecondaryTable;
/*      */ import javax.persistence.SecondaryTables;
/*      */ import javax.persistence.SequenceGenerator;
/*      */ import javax.persistence.SqlResultSetMapping;
/*      */ import javax.persistence.SqlResultSetMappings;
/*      */ import javax.persistence.Table;
/*      */ import javax.persistence.TableGenerator;
/*      */ import javax.persistence.Temporal;
/*      */ import javax.persistence.TemporalType;
/*      */ import javax.persistence.Transient;
/*      */ import javax.persistence.UniqueConstraint;
/*      */ import javax.persistence.Version;
/*      */ import org.apache.commons.logging.Log;
/*      */ import org.apache.commons.logging.LogFactory;
/*      */ import org.dom4j.Attribute;
/*      */ import org.dom4j.Element;
/*      */ import org.hibernate.AnnotationException;
/*      */ import org.hibernate.annotations.AccessType;
/*      */ import org.hibernate.annotations.CollectionOfElements;
/*      */ import org.hibernate.annotations.Columns;
/*      */ import org.hibernate.annotations.common.annotationfactory.AnnotationDescriptor;
/*      */ import org.hibernate.annotations.common.annotationfactory.AnnotationFactory;
/*      */ import org.hibernate.annotations.common.reflection.AnnotationReader;
/*      */ import org.hibernate.annotations.common.reflection.Filter;
/*      */ import org.hibernate.annotations.common.reflection.ReflectionUtil;
/*      */ import org.hibernate.util.ReflectHelper;
/*      */ import org.hibernate.util.StringHelper;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ public class EJB3OverridenAnnotationReader
/*      */   implements AnnotationReader
/*      */ {
/*  107 */   private static Log log = LogFactory.getLog(EJB3OverridenAnnotationReader.class);
/*      */   private static final Map<Class, String> annotationToXml;
/*      */   private static final String SCHEMA_VALIDATION = "Activate schema validation for more informations";
/*  110 */   private static final Filter FILTER = new Filter() {
/*      */     public boolean returnStatic() {
/*  112 */       return false;
/*      */     }
/*      */     
/*      */ 
/*  116 */     public boolean returnTransient() { return false; }
/*      */   };
/*      */   private XMLContext xmlContext;
/*      */   private String className;
/*      */   
/*  121 */   static { annotationToXml = new HashMap();
/*  122 */     annotationToXml.put(Entity.class, "entity");
/*  123 */     annotationToXml.put(MappedSuperclass.class, "mapped-superclass");
/*  124 */     annotationToXml.put(Embeddable.class, "embeddable");
/*  125 */     annotationToXml.put(Table.class, "table");
/*  126 */     annotationToXml.put(SecondaryTable.class, "secondary-table");
/*  127 */     annotationToXml.put(SecondaryTables.class, "secondary-table");
/*  128 */     annotationToXml.put(PrimaryKeyJoinColumn.class, "primary-key-join-column");
/*  129 */     annotationToXml.put(PrimaryKeyJoinColumns.class, "primary-key-join-column");
/*  130 */     annotationToXml.put(IdClass.class, "id-class");
/*  131 */     annotationToXml.put(Inheritance.class, "inheritance");
/*  132 */     annotationToXml.put(DiscriminatorValue.class, "discriminator-value");
/*  133 */     annotationToXml.put(DiscriminatorColumn.class, "discriminator-column");
/*  134 */     annotationToXml.put(SequenceGenerator.class, "sequence-generator");
/*  135 */     annotationToXml.put(TableGenerator.class, "table-generator");
/*  136 */     annotationToXml.put(NamedQuery.class, "named-query");
/*  137 */     annotationToXml.put(NamedQueries.class, "named-query");
/*  138 */     annotationToXml.put(NamedNativeQuery.class, "named-native-query");
/*  139 */     annotationToXml.put(NamedNativeQueries.class, "named-native-query");
/*  140 */     annotationToXml.put(SqlResultSetMapping.class, "sql-result-set-mapping");
/*  141 */     annotationToXml.put(SqlResultSetMappings.class, "sql-result-set-mapping");
/*  142 */     annotationToXml.put(ExcludeDefaultListeners.class, "exclude-default-listeners");
/*  143 */     annotationToXml.put(ExcludeSuperclassListeners.class, "exclude-superclass-listeners");
/*  144 */     annotationToXml.put(AccessType.class, "access");
/*  145 */     annotationToXml.put(AttributeOverride.class, "attribute-override");
/*  146 */     annotationToXml.put(AttributeOverrides.class, "attribute-override");
/*  147 */     annotationToXml.put(AttributeOverride.class, "association-override");
/*  148 */     annotationToXml.put(AttributeOverrides.class, "association-override");
/*  149 */     annotationToXml.put(Id.class, "id");
/*  150 */     annotationToXml.put(EmbeddedId.class, "embedded-id");
/*  151 */     annotationToXml.put(GeneratedValue.class, "generated-value");
/*  152 */     annotationToXml.put(Column.class, "column");
/*  153 */     annotationToXml.put(Columns.class, "column");
/*  154 */     annotationToXml.put(Temporal.class, "temporal");
/*  155 */     annotationToXml.put(Lob.class, "lob");
/*  156 */     annotationToXml.put(Enumerated.class, "enumerated");
/*  157 */     annotationToXml.put(Version.class, "version");
/*  158 */     annotationToXml.put(Transient.class, "transient");
/*  159 */     annotationToXml.put(Basic.class, "basic");
/*  160 */     annotationToXml.put(Embedded.class, "embedded");
/*  161 */     annotationToXml.put(ManyToOne.class, "many-to-one");
/*  162 */     annotationToXml.put(OneToOne.class, "one-to-one");
/*  163 */     annotationToXml.put(OneToMany.class, "one-to-many");
/*  164 */     annotationToXml.put(ManyToMany.class, "many-to-many");
/*  165 */     annotationToXml.put(JoinTable.class, "join-table");
/*  166 */     annotationToXml.put(JoinColumn.class, "join-column");
/*  167 */     annotationToXml.put(JoinColumns.class, "join-column");
/*  168 */     annotationToXml.put(MapKey.class, "map-key");
/*  169 */     annotationToXml.put(OrderBy.class, "order-by");
/*  170 */     annotationToXml.put(EntityListeners.class, "entity-listeners");
/*  171 */     annotationToXml.put(PrePersist.class, "pre-persist");
/*  172 */     annotationToXml.put(PreRemove.class, "pre-remove");
/*  173 */     annotationToXml.put(PreUpdate.class, "pre-update");
/*  174 */     annotationToXml.put(PostPersist.class, "post-persist");
/*  175 */     annotationToXml.put(PostRemove.class, "post-remove");
/*  176 */     annotationToXml.put(PostUpdate.class, "post-update");
/*  177 */     annotationToXml.put(PostLoad.class, "post-load");
/*      */   }
/*      */   
/*      */ 
/*      */   private String propertyName;
/*      */   
/*      */   private PropertyType propertyType;
/*      */   private transient Annotation[] annotations;
/*      */   private transient Map<Class, Annotation> annotationsMap;
/*      */   private static final String WORD_SEPARATOR = "-";
/*      */   private transient List<Element> elementsForProperty;
/*      */   private AccessibleObject mirroredAttribute;
/*      */   private final AnnotatedElement element;
/*      */   private static enum PropertyType
/*      */   {
/*  192 */     PROPERTY, 
/*  193 */     FIELD, 
/*  194 */     METHOD;
/*      */     
/*      */     private PropertyType() {} }
/*      */   
/*  198 */   public EJB3OverridenAnnotationReader(AnnotatedElement el, XMLContext xmlContext) { this.element = el;
/*  199 */     this.xmlContext = xmlContext;
/*  200 */     if ((el instanceof Class)) {
/*  201 */       Class clazz = (Class)el;
/*  202 */       this.className = clazz.getName();
/*      */     }
/*  204 */     else if ((el instanceof Field)) {
/*  205 */       Field field = (Field)el;
/*  206 */       this.className = field.getDeclaringClass().getName();
/*  207 */       this.propertyName = field.getName();
/*  208 */       this.propertyType = PropertyType.FIELD;
/*  209 */       String expectedGetter = "get" + Character.toUpperCase(this.propertyName.charAt(0)) + this.propertyName.substring(1);
/*      */       
/*      */       try
/*      */       {
/*  213 */         this.mirroredAttribute = field.getDeclaringClass().getDeclaredMethod(expectedGetter, new Class[0]);
/*      */ 
/*      */       }
/*      */       catch (NoSuchMethodException e) {}
/*      */ 
/*      */     }
/*  219 */     else if ((el instanceof Method)) {
/*  220 */       Method method = (Method)el;
/*  221 */       this.className = method.getDeclaringClass().getName();
/*  222 */       this.propertyName = method.getName();
/*  223 */       if (ReflectionUtil.isProperty(method, null, FILTER))
/*      */       {
/*      */ 
/*      */ 
/*      */ 
/*  228 */         if (this.propertyName.startsWith("get")) {
/*  229 */           this.propertyName = Introspector.decapitalize(this.propertyName.substring("get".length()));
/*      */         }
/*  231 */         else if (this.propertyName.startsWith("is")) {
/*  232 */           this.propertyName = Introspector.decapitalize(this.propertyName.substring("is".length()));
/*      */         }
/*      */         else {
/*  235 */           throw new RuntimeException("Method " + this.propertyName + " is not a property getter");
/*      */         }
/*  237 */         this.propertyType = PropertyType.PROPERTY;
/*      */         try {
/*  239 */           this.mirroredAttribute = method.getDeclaringClass().getDeclaredField(this.propertyName);
/*      */ 
/*      */         }
/*      */         catch (NoSuchFieldException e) {}
/*      */       }
/*      */       else
/*      */       {
/*  246 */         this.propertyType = PropertyType.METHOD;
/*      */       }
/*      */     }
/*      */     else {
/*  250 */       this.className = null;
/*  251 */       this.propertyName = null;
/*      */     }
/*      */   }
/*      */   
/*      */   public <T extends Annotation> T getAnnotation(Class<T> annotationType) {
/*  256 */     initAnnotations();
/*  257 */     return (Annotation)this.annotationsMap.get(annotationType);
/*      */   }
/*      */   
/*      */   public <T extends Annotation> boolean isAnnotationPresent(Class<T> annotationType) {
/*  261 */     initAnnotations();
/*  262 */     return (Annotation)this.annotationsMap.get(annotationType) != null;
/*      */   }
/*      */   
/*      */   public Annotation[] getAnnotations() {
/*  266 */     initAnnotations();
/*  267 */     return this.annotations;
/*      */   }
/*      */   
/*      */   private void initAnnotations() {
/*  271 */     if (this.annotations == null) {
/*  272 */       XMLContext.Default defaults = this.xmlContext.getDefault(this.className);
/*  273 */       if ((this.className != null) && (this.propertyName == null))
/*      */       {
/*  275 */         Element tree = this.xmlContext.getXMLTree(this.className, null);
/*  276 */         Annotation[] annotations = getJavaAnnotations();
/*  277 */         List<Annotation> annotationList = new ArrayList(annotations.length + 5);
/*  278 */         this.annotationsMap = new HashMap(annotations.length + 5);
/*  279 */         for (Annotation annotation : annotations) {
/*  280 */           if (!annotationToXml.containsKey(annotation.annotationType()))
/*      */           {
/*  282 */             annotationList.add(annotation);
/*      */           }
/*      */         }
/*  285 */         addIfNotNull(annotationList, getEntity(tree, defaults));
/*  286 */         addIfNotNull(annotationList, getMappedSuperclass(tree, defaults));
/*  287 */         addIfNotNull(annotationList, getEmbeddable(tree, defaults));
/*  288 */         addIfNotNull(annotationList, getTable(tree, defaults));
/*  289 */         addIfNotNull(annotationList, getSecondaryTables(tree, defaults));
/*  290 */         addIfNotNull(annotationList, getPrimaryKeyJoinColumns(tree, defaults));
/*  291 */         addIfNotNull(annotationList, getIdClass(tree, defaults));
/*  292 */         addIfNotNull(annotationList, getInheritance(tree, defaults));
/*  293 */         addIfNotNull(annotationList, getDiscriminatorValue(tree, defaults));
/*  294 */         addIfNotNull(annotationList, getDiscriminatorColumn(tree, defaults));
/*  295 */         addIfNotNull(annotationList, getSequenceGenerator(tree, defaults));
/*  296 */         addIfNotNull(annotationList, getTableGenerator(tree, defaults));
/*  297 */         addIfNotNull(annotationList, getNamedQueries(tree, defaults));
/*  298 */         addIfNotNull(annotationList, getNamedNativeQueries(tree, defaults));
/*  299 */         addIfNotNull(annotationList, getSqlResultSetMappings(tree, defaults));
/*  300 */         addIfNotNull(annotationList, getExcludeDefaultListeners(tree, defaults));
/*  301 */         addIfNotNull(annotationList, getExcludeSuperclassListeners(tree, defaults));
/*  302 */         addIfNotNull(annotationList, getAccessType(tree, defaults));
/*  303 */         addIfNotNull(annotationList, getAttributeOverrides(tree, defaults));
/*  304 */         addIfNotNull(annotationList, getAssociationOverrides(tree, defaults));
/*  305 */         addIfNotNull(annotationList, getEntityListeners(tree, defaults));
/*      */         
/*  307 */         this.annotations = ((Annotation[])annotationList.toArray(new Annotation[annotationList.size()]));
/*  308 */         for (Annotation ann : this.annotations) {
/*  309 */           this.annotationsMap.put(ann.annotationType(), ann);
/*      */         }
/*  311 */         checkForOrphanProperties(tree);
/*      */       }
/*  313 */       else if (this.className != null) {
/*  314 */         Element tree = this.xmlContext.getXMLTree(this.className, this.propertyName);
/*  315 */         Annotation[] annotations = getJavaAnnotations();
/*  316 */         List<Annotation> annotationList = new ArrayList(annotations.length + 5);
/*  317 */         this.annotationsMap = new HashMap(annotations.length + 5);
/*  318 */         for (Annotation annotation : annotations) {
/*  319 */           if (!annotationToXml.containsKey(annotation.annotationType()))
/*      */           {
/*  321 */             annotationList.add(annotation);
/*      */           }
/*      */         }
/*  324 */         preCalculateElementsForProperty(tree);
/*  325 */         Transient transientAnn = getTransient(defaults);
/*  326 */         if (transientAnn != null) {
/*  327 */           annotationList.add(transientAnn);
/*      */         }
/*      */         else {
/*  330 */           if (defaults.canUseJavaAnnotations()) {
/*  331 */             Annotation annotation = getJavaAnnotation(AccessType.class);
/*  332 */             addIfNotNull(annotationList, annotation);
/*      */           }
/*  334 */           getId(annotationList, defaults);
/*  335 */           getEmbeddedId(annotationList, defaults);
/*  336 */           getEmbedded(annotationList, defaults);
/*  337 */           getBasic(annotationList, defaults);
/*  338 */           getVersion(annotationList, defaults);
/*  339 */           getAssociation(ManyToOne.class, annotationList, defaults);
/*  340 */           getAssociation(OneToOne.class, annotationList, defaults);
/*  341 */           getAssociation(OneToMany.class, annotationList, defaults);
/*  342 */           getAssociation(ManyToMany.class, annotationList, defaults);
/*  343 */           addIfNotNull(annotationList, getSequenceGenerator(this.elementsForProperty, defaults));
/*  344 */           addIfNotNull(annotationList, getTableGenerator(this.elementsForProperty, defaults));
/*  345 */           addIfNotNull(annotationList, getAttributeOverrides(this.elementsForProperty, defaults));
/*      */         }
/*      */         
/*  348 */         processEventAnnotations(annotationList, defaults);
/*      */         
/*  350 */         this.annotations = ((Annotation[])annotationList.toArray(new Annotation[annotationList.size()]));
/*  351 */         for (Annotation ann : this.annotations) {
/*  352 */           this.annotationsMap.put(ann.annotationType(), ann);
/*      */         }
/*      */       }
/*      */       else {
/*  356 */         this.annotations = getJavaAnnotations();
/*  357 */         this.annotationsMap = new HashMap(this.annotations.length + 5);
/*  358 */         for (Annotation ann : this.annotations) {
/*  359 */           this.annotationsMap.put(ann.annotationType(), ann);
/*      */         }
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */   private void checkForOrphanProperties(Element tree) {
/*      */     Class clazz;
/*      */     try {
/*  368 */       clazz = ReflectHelper.classForName(this.className, getClass());
/*      */     }
/*      */     catch (ClassNotFoundException e) {
/*  371 */       return;
/*      */     }
/*  373 */     Element element = tree != null ? tree.element("attributes") : null;
/*      */     Set<String> properties;
/*  375 */     if (element != null)
/*      */     {
/*      */ 
/*  378 */       properties = new HashSet();
/*  379 */       for (Field field : clazz.getFields()) {
/*  380 */         properties.add(field.getName());
/*      */       }
/*  382 */       for (Method method : clazz.getMethods()) {
/*  383 */         String name = method.getName();
/*  384 */         if (name.startsWith("get")) {
/*  385 */           properties.add(Introspector.decapitalize(name.substring("get".length())));
/*      */         }
/*  387 */         else if (name.startsWith("is")) {
/*  388 */           properties.add(Introspector.decapitalize(name.substring("is".length())));
/*      */         }
/*      */       }
/*  391 */       for (Element subelement : element.elements()) {
/*  392 */         String propertyName = subelement.attributeValue("name");
/*  393 */         if (!properties.contains(propertyName)) {
/*  394 */           log.warn("Property " + StringHelper.qualify(this.className, propertyName) + " not found in class" + " but described in <mapping-file/> (possible typo error)");
/*      */         }
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   private Annotation addIfNotNull(List<Annotation> annotationList, Annotation element)
/*      */   {
/*  405 */     if (element != null) {
/*  406 */       annotationList.add(element);
/*      */     }
/*  408 */     return element;
/*      */   }
/*      */   
/*      */   private Annotation getTableGenerator(List<Element> elementsForProperty, XMLContext.Default defaults)
/*      */   {
/*  413 */     for (Element element : elementsForProperty) {
/*  414 */       Element subelement = element != null ? element.element((String)annotationToXml.get(TableGenerator.class)) : null;
/*  415 */       if (subelement != null) {
/*  416 */         return buildTableGeneratorAnnotation(subelement, defaults);
/*      */       }
/*      */     }
/*  419 */     if ((elementsForProperty.size() == 0) && (defaults.canUseJavaAnnotations())) {
/*  420 */       return getJavaAnnotation(TableGenerator.class);
/*      */     }
/*      */     
/*  423 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */   private Annotation getSequenceGenerator(List<Element> elementsForProperty, XMLContext.Default defaults)
/*      */   {
/*  429 */     for (Element element : elementsForProperty) {
/*  430 */       Element subelement = element != null ? element.element((String)annotationToXml.get(SequenceGenerator.class)) : null;
/*  431 */       if (subelement != null) {
/*  432 */         return buildSequenceGeneratorAnnotation(subelement);
/*      */       }
/*      */     }
/*  435 */     if ((elementsForProperty.size() == 0) && (defaults.canUseJavaAnnotations())) {
/*  436 */       return getJavaAnnotation(SequenceGenerator.class);
/*      */     }
/*      */     
/*  439 */     return null;
/*      */   }
/*      */   
/*      */   private void processEventAnnotations(List<Annotation> annotationList, XMLContext.Default defaults)
/*      */   {
/*  444 */     boolean eventElement = false;
/*  445 */     for (Element element : this.elementsForProperty) {
/*  446 */       String elementName = element.getName();
/*  447 */       if ("pre-persist".equals(elementName)) {
/*  448 */         AnnotationDescriptor ad = new AnnotationDescriptor(PrePersist.class);
/*  449 */         annotationList.add(AnnotationFactory.create(ad));
/*  450 */         eventElement = true;
/*      */       }
/*  452 */       else if ("pre-remove".equals(elementName)) {
/*  453 */         AnnotationDescriptor ad = new AnnotationDescriptor(PreRemove.class);
/*  454 */         annotationList.add(AnnotationFactory.create(ad));
/*  455 */         eventElement = true;
/*      */       }
/*  457 */       else if ("pre-update".equals(elementName)) {
/*  458 */         AnnotationDescriptor ad = new AnnotationDescriptor(PreUpdate.class);
/*  459 */         annotationList.add(AnnotationFactory.create(ad));
/*  460 */         eventElement = true;
/*      */       }
/*  462 */       else if ("post-persist".equals(elementName)) {
/*  463 */         AnnotationDescriptor ad = new AnnotationDescriptor(PostPersist.class);
/*  464 */         annotationList.add(AnnotationFactory.create(ad));
/*  465 */         eventElement = true;
/*      */       }
/*  467 */       else if ("post-remove".equals(elementName)) {
/*  468 */         AnnotationDescriptor ad = new AnnotationDescriptor(PostRemove.class);
/*  469 */         annotationList.add(AnnotationFactory.create(ad));
/*  470 */         eventElement = true;
/*      */       }
/*  472 */       else if ("post-update".equals(elementName)) {
/*  473 */         AnnotationDescriptor ad = new AnnotationDescriptor(PostUpdate.class);
/*  474 */         annotationList.add(AnnotationFactory.create(ad));
/*  475 */         eventElement = true;
/*      */       }
/*  477 */       else if ("post-load".equals(elementName)) {
/*  478 */         AnnotationDescriptor ad = new AnnotationDescriptor(PostLoad.class);
/*  479 */         annotationList.add(AnnotationFactory.create(ad));
/*  480 */         eventElement = true;
/*      */       }
/*      */     }
/*  483 */     if ((!eventElement) && (defaults.canUseJavaAnnotations())) {
/*  484 */       Annotation ann = getJavaAnnotation(PrePersist.class);
/*  485 */       addIfNotNull(annotationList, ann);
/*  486 */       ann = getJavaAnnotation(PreRemove.class);
/*  487 */       addIfNotNull(annotationList, ann);
/*  488 */       ann = getJavaAnnotation(PreUpdate.class);
/*  489 */       addIfNotNull(annotationList, ann);
/*  490 */       ann = getJavaAnnotation(PostPersist.class);
/*  491 */       addIfNotNull(annotationList, ann);
/*  492 */       ann = getJavaAnnotation(PostRemove.class);
/*  493 */       addIfNotNull(annotationList, ann);
/*  494 */       ann = getJavaAnnotation(PostUpdate.class);
/*  495 */       addIfNotNull(annotationList, ann);
/*  496 */       ann = getJavaAnnotation(PostLoad.class);
/*  497 */       addIfNotNull(annotationList, ann);
/*      */     }
/*      */   }
/*      */   
/*      */   private EntityListeners getEntityListeners(Element tree, XMLContext.Default defaults) {
/*  502 */     Element element = tree != null ? tree.element("entity-listeners") : null;
/*  503 */     if (element != null) {
/*  504 */       List<Class> entityListenerClasses = new ArrayList();
/*  505 */       for (Element subelement : element.elements("entity-listener")) {
/*  506 */         String className = subelement.attributeValue("class");
/*      */         try {
/*  508 */           entityListenerClasses.add(ReflectHelper.classForName(XMLContext.buildSafeClassName(className, defaults), getClass()));
/*      */ 
/*      */ 
/*      */         }
/*      */         catch (ClassNotFoundException e)
/*      */         {
/*      */ 
/*      */ 
/*  516 */           throw new AnnotationException("Unable to find " + element.getPath() + ".class: " + className, e);
/*      */         }
/*      */       }
/*      */       
/*      */ 
/*  521 */       AnnotationDescriptor ad = new AnnotationDescriptor(EntityListeners.class);
/*  522 */       ad.setValue("value", entityListenerClasses.toArray(new Class[entityListenerClasses.size()]));
/*  523 */       return (EntityListeners)AnnotationFactory.create(ad);
/*      */     }
/*  525 */     if (defaults.canUseJavaAnnotations()) {
/*  526 */       return (EntityListeners)getJavaAnnotation(EntityListeners.class);
/*      */     }
/*      */     
/*  529 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */   private JoinTable overridesDefaultsInJoinTable(Annotation annotation, XMLContext.Default defaults)
/*      */   {
/*  535 */     boolean defaultToJoinTable = (!isJavaAnnotationPresent(JoinColumn.class)) && (!isJavaAnnotationPresent(JoinColumns.class));
/*      */     
/*  537 */     Class<? extends Annotation> annotationClass = annotation.annotationType();
/*  538 */     defaultToJoinTable = (defaultToJoinTable) && (((annotationClass == ManyToMany.class) && (StringHelper.isEmpty(((ManyToMany)annotation).mappedBy()))) || ((annotationClass == OneToMany.class) && (StringHelper.isEmpty(((OneToMany)annotation).mappedBy()))) || (annotationClass == CollectionOfElements.class));
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*  543 */     Class<JoinTable> annotationType = JoinTable.class;
/*  544 */     if ((defaultToJoinTable) && ((StringHelper.isNotEmpty(defaults.getCatalog())) || (StringHelper.isNotEmpty(defaults.getSchema()))))
/*      */     {
/*      */ 
/*  547 */       AnnotationDescriptor ad = new AnnotationDescriptor(annotationType);
/*  548 */       if (defaults.canUseJavaAnnotations()) {
/*  549 */         JoinTable table = (JoinTable)getJavaAnnotation(annotationType);
/*  550 */         if (table != null) {
/*  551 */           ad.setValue("name", table.name());
/*  552 */           ad.setValue("schema", table.schema());
/*  553 */           ad.setValue("catalog", table.catalog());
/*  554 */           ad.setValue("uniqueConstraints", table.uniqueConstraints());
/*  555 */           ad.setValue("joinColumns", table.joinColumns());
/*  556 */           ad.setValue("inverseJoinColumns", table.inverseJoinColumns());
/*      */         }
/*      */       }
/*  559 */       if ((StringHelper.isEmpty((String)ad.valueOf("schema"))) && (StringHelper.isNotEmpty(defaults.getSchema())))
/*      */       {
/*  561 */         ad.setValue("schema", defaults.getSchema());
/*      */       }
/*  563 */       if ((StringHelper.isEmpty((String)ad.valueOf("catalog"))) && (StringHelper.isNotEmpty(defaults.getCatalog())))
/*      */       {
/*  565 */         ad.setValue("catalog", defaults.getCatalog());
/*      */       }
/*  567 */       return (JoinTable)AnnotationFactory.create(ad);
/*      */     }
/*  569 */     if (defaults.canUseJavaAnnotations()) {
/*  570 */       return (JoinTable)getJavaAnnotation(annotationType);
/*      */     }
/*      */     
/*  573 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */ 
/*      */   private void getJoinTable(List<Annotation> annotationList, Element tree, XMLContext.Default defaults)
/*      */   {
/*  581 */     Element subelement = tree == null ? null : tree.element("join-table");
/*  582 */     Class<JoinTable> annotationType = JoinTable.class;
/*  583 */     if (subelement != null)
/*      */     {
/*  585 */       AnnotationDescriptor annotation = new AnnotationDescriptor(annotationType);
/*  586 */       copyStringAttribute(annotation, subelement, "name", false);
/*  587 */       copyStringAttribute(annotation, subelement, "catalog", false);
/*  588 */       if ((StringHelper.isNotEmpty(defaults.getCatalog())) && (StringHelper.isEmpty((String)annotation.valueOf("catalog"))))
/*      */       {
/*  590 */         annotation.setValue("catalog", defaults.getCatalog());
/*      */       }
/*  592 */       copyStringAttribute(annotation, subelement, "schema", false);
/*  593 */       if ((StringHelper.isNotEmpty(defaults.getSchema())) && (StringHelper.isEmpty((String)annotation.valueOf("schema"))))
/*      */       {
/*  595 */         annotation.setValue("schema", defaults.getSchema());
/*      */       }
/*  597 */       buildUniqueConstraints(annotation, subelement);
/*  598 */       annotation.setValue("joinColumns", getJoinColumns(subelement, false));
/*  599 */       annotation.setValue("inverseJoinColumns", getJoinColumns(subelement, true));
/*  600 */       annotationList.add(AnnotationFactory.create(annotation));
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private void getAssociation(Class<? extends Annotation> annotationType, List<Annotation> annotationList, XMLContext.Default defaults)
/*      */   {
/*  607 */     String xmlName = (String)annotationToXml.get(annotationType);
/*  608 */     for (Element element : this.elementsForProperty) {
/*  609 */       if (xmlName.equals(element.getName())) {
/*  610 */         AnnotationDescriptor ad = new AnnotationDescriptor(annotationType);
/*  611 */         String className = element.attributeValue("target-entity");
/*  612 */         if (className != null) {
/*      */           Class clazz;
/*      */           try {
/*  615 */             clazz = ReflectHelper.classForName(XMLContext.buildSafeClassName(className, defaults), getClass());
/*      */ 
/*      */           }
/*      */           catch (ClassNotFoundException e)
/*      */           {
/*      */ 
/*  621 */             throw new AnnotationException("Unable to find " + element.getPath() + "target-entity: " + className, e);
/*      */           }
/*      */           
/*      */ 
/*  625 */           ad.setValue("targetEntity", clazz);
/*      */         }
/*  627 */         getFetchType(ad, element);
/*  628 */         getCascades(ad, element, defaults);
/*  629 */         getJoinTable(annotationList, element, defaults);
/*  630 */         buildJoinColumns(annotationList, element, defaults);
/*  631 */         Annotation annotation = getPrimaryKeyJoinColumns(element, defaults);
/*  632 */         addIfNotNull(annotationList, annotation);
/*  633 */         copyBooleanAttribute(ad, element, "optional");
/*  634 */         copyStringAttribute(ad, element, "mapped-by", false);
/*  635 */         getOrderBy(annotationList, element, defaults);
/*  636 */         getMapKey(annotationList, element, defaults);
/*  637 */         annotationList.add(AnnotationFactory.create(ad));
/*      */       }
/*      */     }
/*  640 */     if ((this.elementsForProperty.size() == 0) && (defaults.canUseJavaAnnotations())) {
/*  641 */       Annotation annotation = getJavaAnnotation(annotationType);
/*  642 */       if (annotation != null) {
/*  643 */         annotationList.add(annotation);
/*  644 */         annotation = overridesDefaultsInJoinTable(annotation, defaults);
/*  645 */         addIfNotNull(annotationList, annotation);
/*  646 */         annotation = getJavaAnnotation(JoinColumn.class);
/*  647 */         addIfNotNull(annotationList, annotation);
/*  648 */         annotation = getJavaAnnotation(JoinColumns.class);
/*  649 */         addIfNotNull(annotationList, annotation);
/*  650 */         annotation = getJavaAnnotation(PrimaryKeyJoinColumn.class);
/*  651 */         addIfNotNull(annotationList, annotation);
/*  652 */         annotation = getJavaAnnotation(PrimaryKeyJoinColumns.class);
/*  653 */         addIfNotNull(annotationList, annotation);
/*  654 */         annotation = getJavaAnnotation(MapKey.class);
/*  655 */         addIfNotNull(annotationList, annotation);
/*  656 */         annotation = getJavaAnnotation(OrderBy.class);
/*  657 */         addIfNotNull(annotationList, annotation);
/*  658 */         annotation = getJavaAnnotation(AttributeOverride.class);
/*  659 */         addIfNotNull(annotationList, annotation);
/*  660 */         annotation = getJavaAnnotation(AttributeOverrides.class);
/*  661 */         addIfNotNull(annotationList, annotation);
/*  662 */         annotation = getJavaAnnotation(AssociationOverride.class);
/*  663 */         addIfNotNull(annotationList, annotation);
/*  664 */         annotation = getJavaAnnotation(AssociationOverrides.class);
/*  665 */         addIfNotNull(annotationList, annotation);
/*  666 */         annotation = getJavaAnnotation(Lob.class);
/*  667 */         addIfNotNull(annotationList, annotation);
/*  668 */         annotation = getJavaAnnotation(Enumerated.class);
/*  669 */         addIfNotNull(annotationList, annotation);
/*  670 */         annotation = getJavaAnnotation(Temporal.class);
/*  671 */         addIfNotNull(annotationList, annotation);
/*  672 */         annotation = getJavaAnnotation(Column.class);
/*  673 */         addIfNotNull(annotationList, annotation);
/*  674 */         annotation = getJavaAnnotation(Columns.class);
/*  675 */         addIfNotNull(annotationList, annotation);
/*      */       }
/*  677 */       else if (isJavaAnnotationPresent(CollectionOfElements.class)) {
/*  678 */         annotation = overridesDefaultsInJoinTable(getJavaAnnotation(CollectionOfElements.class), defaults);
/*  679 */         addIfNotNull(annotationList, annotation);
/*  680 */         annotation = getJavaAnnotation(JoinColumn.class);
/*  681 */         addIfNotNull(annotationList, annotation);
/*  682 */         annotation = getJavaAnnotation(JoinColumns.class);
/*  683 */         addIfNotNull(annotationList, annotation);
/*  684 */         annotation = getJavaAnnotation(PrimaryKeyJoinColumn.class);
/*  685 */         addIfNotNull(annotationList, annotation);
/*  686 */         annotation = getJavaAnnotation(PrimaryKeyJoinColumns.class);
/*  687 */         addIfNotNull(annotationList, annotation);
/*  688 */         annotation = getJavaAnnotation(MapKey.class);
/*  689 */         addIfNotNull(annotationList, annotation);
/*  690 */         annotation = getJavaAnnotation(OrderBy.class);
/*  691 */         addIfNotNull(annotationList, annotation);
/*  692 */         annotation = getJavaAnnotation(AttributeOverride.class);
/*  693 */         addIfNotNull(annotationList, annotation);
/*  694 */         annotation = getJavaAnnotation(AttributeOverrides.class);
/*  695 */         addIfNotNull(annotationList, annotation);
/*  696 */         annotation = getJavaAnnotation(AssociationOverride.class);
/*  697 */         addIfNotNull(annotationList, annotation);
/*  698 */         annotation = getJavaAnnotation(AssociationOverrides.class);
/*  699 */         addIfNotNull(annotationList, annotation);
/*  700 */         annotation = getJavaAnnotation(Lob.class);
/*  701 */         addIfNotNull(annotationList, annotation);
/*  702 */         annotation = getJavaAnnotation(Enumerated.class);
/*  703 */         addIfNotNull(annotationList, annotation);
/*  704 */         annotation = getJavaAnnotation(Temporal.class);
/*  705 */         addIfNotNull(annotationList, annotation);
/*  706 */         annotation = getJavaAnnotation(Column.class);
/*  707 */         addIfNotNull(annotationList, annotation);
/*  708 */         annotation = getJavaAnnotation(Columns.class);
/*  709 */         addIfNotNull(annotationList, annotation);
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */   private void getOrderBy(List<Annotation> annotationList, Element element, XMLContext.Default defaults) {
/*  715 */     Element subelement = element != null ? element.element("order-by") : null;
/*  716 */     if (subelement != null) {
/*  717 */       String orderByString = subelement.getTextTrim();
/*  718 */       AnnotationDescriptor ad = new AnnotationDescriptor(OrderBy.class);
/*  719 */       if (StringHelper.isNotEmpty(orderByString)) ad.setValue("value", orderByString);
/*  720 */       annotationList.add(AnnotationFactory.create(ad));
/*      */     }
/*      */   }
/*      */   
/*      */   private void getMapKey(List<Annotation> annotationList, Element element, XMLContext.Default defaults) {
/*  725 */     Element subelement = element != null ? element.element("map-key") : null;
/*  726 */     if (subelement != null) {
/*  727 */       String mapKeyString = subelement.attributeValue("name");
/*  728 */       AnnotationDescriptor ad = new AnnotationDescriptor(MapKey.class);
/*  729 */       if (StringHelper.isNotEmpty(mapKeyString)) ad.setValue("name", mapKeyString);
/*  730 */       annotationList.add(AnnotationFactory.create(ad));
/*      */     }
/*      */   }
/*      */   
/*      */   private void buildJoinColumns(List<Annotation> annotationList, Element element, XMLContext.Default defaults) {
/*  735 */     JoinColumn[] joinColumns = getJoinColumns(element, false);
/*  736 */     if (joinColumns.length > 0) {
/*  737 */       AnnotationDescriptor ad = new AnnotationDescriptor(JoinColumns.class);
/*  738 */       ad.setValue("value", joinColumns);
/*  739 */       annotationList.add(AnnotationFactory.create(ad));
/*      */     }
/*      */   }
/*      */   
/*      */   private void getCascades(AnnotationDescriptor ad, Element element, XMLContext.Default defaults) {
/*  744 */     List<Element> elements = element != null ? element.elements("cascade") : new ArrayList(0);
/*  745 */     List<CascadeType> cascades = new ArrayList();
/*  746 */     for (Element subelement : elements) {
/*  747 */       if (subelement.element("cascade-all") != null) cascades.add(CascadeType.ALL);
/*  748 */       if (subelement.element("cascade-persist") != null) cascades.add(CascadeType.PERSIST);
/*  749 */       if (subelement.element("cascade-merge") != null) cascades.add(CascadeType.MERGE);
/*  750 */       if (subelement.element("cascade-remove") != null) cascades.add(CascadeType.REMOVE);
/*  751 */       if (subelement.element("cascade-refresh") != null) cascades.add(CascadeType.REFRESH);
/*      */     }
/*  753 */     if ((Boolean.TRUE.equals(defaults.getCascadePersist())) && (!cascades.contains(CascadeType.ALL)) && (!cascades.contains(CascadeType.PERSIST)))
/*      */     {
/*  755 */       cascades.add(CascadeType.PERSIST);
/*      */     }
/*  757 */     if (cascades.size() > 0) {
/*  758 */       ad.setValue("cascade", cascades.toArray(new CascadeType[cascades.size()]));
/*      */     }
/*      */   }
/*      */   
/*      */   private void getEmbedded(List<Annotation> annotationList, XMLContext.Default defaults) {
/*  763 */     for (Element element : this.elementsForProperty) {
/*  764 */       if ("embedded".equals(element.getName())) {
/*  765 */         AnnotationDescriptor ad = new AnnotationDescriptor(Embedded.class);
/*  766 */         annotationList.add(AnnotationFactory.create(ad));
/*      */       }
/*      */     }
/*  769 */     if ((this.elementsForProperty.size() == 0) && (defaults.canUseJavaAnnotations())) {
/*  770 */       Annotation annotation = getJavaAnnotation(Embedded.class);
/*  771 */       if (annotation != null) {
/*  772 */         annotationList.add(annotation);
/*  773 */         annotation = getJavaAnnotation(AttributeOverride.class);
/*  774 */         addIfNotNull(annotationList, annotation);
/*  775 */         annotation = getJavaAnnotation(AttributeOverrides.class);
/*  776 */         addIfNotNull(annotationList, annotation);
/*  777 */         annotation = getJavaAnnotation(AssociationOverride.class);
/*  778 */         addIfNotNull(annotationList, annotation);
/*  779 */         annotation = getJavaAnnotation(AssociationOverrides.class);
/*  780 */         addIfNotNull(annotationList, annotation);
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */   private Transient getTransient(XMLContext.Default defaults) {
/*  786 */     for (Element element : this.elementsForProperty) {
/*  787 */       if ("transient".equals(element.getName())) {
/*  788 */         AnnotationDescriptor ad = new AnnotationDescriptor(Transient.class);
/*  789 */         return (Transient)AnnotationFactory.create(ad);
/*      */       }
/*      */     }
/*  792 */     if ((this.elementsForProperty.size() == 0) && (defaults.canUseJavaAnnotations())) {
/*  793 */       return (Transient)getJavaAnnotation(Transient.class);
/*      */     }
/*      */     
/*  796 */     return null;
/*      */   }
/*      */   
/*      */   private void getVersion(List<Annotation> annotationList, XMLContext.Default defaults)
/*      */   {
/*  801 */     for (Element element : this.elementsForProperty) {
/*  802 */       if ("version".equals(element.getName())) {
/*  803 */         Annotation annotation = buildColumns(element);
/*  804 */         addIfNotNull(annotationList, annotation);
/*  805 */         getTemporal(annotationList, element);
/*  806 */         AnnotationDescriptor basic = new AnnotationDescriptor(Version.class);
/*  807 */         annotationList.add(AnnotationFactory.create(basic));
/*      */       }
/*      */     }
/*  810 */     if ((this.elementsForProperty.size() == 0) && (defaults.canUseJavaAnnotations()))
/*      */     {
/*  812 */       Annotation annotation = getJavaAnnotation(Version.class);
/*  813 */       if (annotation != null) {
/*  814 */         annotationList.add(annotation);
/*  815 */         annotation = getJavaAnnotation(Column.class);
/*  816 */         addIfNotNull(annotationList, annotation);
/*  817 */         annotation = getJavaAnnotation(Columns.class);
/*  818 */         addIfNotNull(annotationList, annotation);
/*  819 */         annotation = getJavaAnnotation(Temporal.class);
/*  820 */         addIfNotNull(annotationList, annotation);
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */   private void getBasic(List<Annotation> annotationList, XMLContext.Default defaults) {
/*  826 */     for (Element element : this.elementsForProperty) {
/*  827 */       if ("basic".equals(element.getName())) {
/*  828 */         Annotation annotation = buildColumns(element);
/*  829 */         addIfNotNull(annotationList, annotation);
/*  830 */         getTemporal(annotationList, element);
/*  831 */         getLob(annotationList, element);
/*  832 */         getEnumerated(annotationList, element);
/*  833 */         AnnotationDescriptor basic = new AnnotationDescriptor(Basic.class);
/*  834 */         getFetchType(basic, element);
/*  835 */         copyBooleanAttribute(basic, element, "optional");
/*  836 */         annotationList.add(AnnotationFactory.create(basic));
/*      */       }
/*      */     }
/*  839 */     if ((this.elementsForProperty.size() == 0) && (defaults.canUseJavaAnnotations()))
/*      */     {
/*  841 */       Annotation annotation = getJavaAnnotation(Basic.class);
/*  842 */       addIfNotNull(annotationList, annotation);
/*  843 */       annotation = getJavaAnnotation(Lob.class);
/*  844 */       addIfNotNull(annotationList, annotation);
/*  845 */       annotation = getJavaAnnotation(Enumerated.class);
/*  846 */       addIfNotNull(annotationList, annotation);
/*  847 */       annotation = getJavaAnnotation(Temporal.class);
/*  848 */       addIfNotNull(annotationList, annotation);
/*  849 */       annotation = getJavaAnnotation(Column.class);
/*  850 */       addIfNotNull(annotationList, annotation);
/*  851 */       annotation = getJavaAnnotation(Columns.class);
/*  852 */       addIfNotNull(annotationList, annotation);
/*  853 */       annotation = getJavaAnnotation(AttributeOverride.class);
/*  854 */       addIfNotNull(annotationList, annotation);
/*  855 */       annotation = getJavaAnnotation(AttributeOverrides.class);
/*  856 */       addIfNotNull(annotationList, annotation);
/*  857 */       annotation = getJavaAnnotation(AssociationOverride.class);
/*  858 */       addIfNotNull(annotationList, annotation);
/*  859 */       annotation = getJavaAnnotation(AssociationOverrides.class);
/*  860 */       addIfNotNull(annotationList, annotation);
/*      */     }
/*      */   }
/*      */   
/*      */   private void getEnumerated(List<Annotation> annotationList, Element element) {
/*  865 */     Element subElement = element != null ? element.element("enumerated") : null;
/*  866 */     if (subElement != null) {
/*  867 */       AnnotationDescriptor ad = new AnnotationDescriptor(Enumerated.class);
/*  868 */       String enumerated = subElement.getTextTrim();
/*  869 */       if ("ORDINAL".equalsIgnoreCase(enumerated)) {
/*  870 */         ad.setValue("value", EnumType.ORDINAL);
/*      */       }
/*  872 */       else if ("STRING".equalsIgnoreCase(enumerated)) {
/*  873 */         ad.setValue("value", EnumType.STRING);
/*      */       }
/*  875 */       else if (StringHelper.isNotEmpty(enumerated)) {
/*  876 */         throw new AnnotationException("Unknown EnumType: " + enumerated + ". " + "Activate schema validation for more informations");
/*      */       }
/*  878 */       annotationList.add(AnnotationFactory.create(ad));
/*      */     }
/*      */   }
/*      */   
/*      */   private void getLob(List<Annotation> annotationList, Element element) {
/*  883 */     Element subElement = element != null ? element.element("lob") : null;
/*  884 */     if (subElement != null) {
/*  885 */       annotationList.add(AnnotationFactory.create(new AnnotationDescriptor(Lob.class)));
/*      */     }
/*      */   }
/*      */   
/*      */   private void getFetchType(AnnotationDescriptor descriptor, Element element) {
/*  890 */     String fetchString = element != null ? element.attributeValue("fetch") : null;
/*  891 */     if (fetchString != null) {
/*  892 */       if ("eager".equalsIgnoreCase(fetchString)) {
/*  893 */         descriptor.setValue("fetch", FetchType.EAGER);
/*      */       }
/*  895 */       else if ("lazy".equalsIgnoreCase(fetchString)) {
/*  896 */         descriptor.setValue("fetch", FetchType.LAZY);
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */   private void getEmbeddedId(List<Annotation> annotationList, XMLContext.Default defaults) {
/*  902 */     for (Element element : this.elementsForProperty) {
/*  903 */       if (("embedded-id".equals(element.getName())) && 
/*  904 */         (isProcessingId(defaults))) {
/*  905 */         Annotation annotation = getAttributeOverrides(element, defaults);
/*  906 */         addIfNotNull(annotationList, annotation);
/*  907 */         annotation = getAssociationOverrides(element, defaults);
/*  908 */         addIfNotNull(annotationList, annotation);
/*  909 */         AnnotationDescriptor ad = new AnnotationDescriptor(EmbeddedId.class);
/*  910 */         annotationList.add(AnnotationFactory.create(ad));
/*      */       }
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*  929 */     if ((this.elementsForProperty.size() == 0) && (defaults.canUseJavaAnnotations())) {
/*  930 */       Annotation annotation = getJavaAnnotation(EmbeddedId.class);
/*  931 */       if (annotation != null) {
/*  932 */         annotationList.add(annotation);
/*  933 */         annotation = getJavaAnnotation(Column.class);
/*  934 */         addIfNotNull(annotationList, annotation);
/*  935 */         annotation = getJavaAnnotation(Columns.class);
/*  936 */         addIfNotNull(annotationList, annotation);
/*  937 */         annotation = getJavaAnnotation(GeneratedValue.class);
/*  938 */         addIfNotNull(annotationList, annotation);
/*  939 */         annotation = getJavaAnnotation(Temporal.class);
/*  940 */         addIfNotNull(annotationList, annotation);
/*  941 */         annotation = getJavaAnnotation(TableGenerator.class);
/*  942 */         addIfNotNull(annotationList, annotation);
/*  943 */         annotation = getJavaAnnotation(SequenceGenerator.class);
/*  944 */         addIfNotNull(annotationList, annotation);
/*  945 */         annotation = getJavaAnnotation(AttributeOverride.class);
/*  946 */         addIfNotNull(annotationList, annotation);
/*  947 */         annotation = getJavaAnnotation(AttributeOverrides.class);
/*  948 */         addIfNotNull(annotationList, annotation);
/*  949 */         annotation = getJavaAnnotation(AssociationOverride.class);
/*  950 */         addIfNotNull(annotationList, annotation);
/*  951 */         annotation = getJavaAnnotation(AssociationOverrides.class);
/*  952 */         addIfNotNull(annotationList, annotation);
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */   private void preCalculateElementsForProperty(Element tree) {
/*  958 */     this.elementsForProperty = new ArrayList();
/*  959 */     Element element = tree != null ? tree.element("attributes") : null;
/*      */     
/*  961 */     if (element != null) {
/*  962 */       for (Element subelement : element.elements()) {
/*  963 */         if (this.propertyName.equals(subelement.attributeValue("name"))) {
/*  964 */           this.elementsForProperty.add(subelement);
/*      */         }
/*      */       }
/*      */     }
/*      */     
/*  969 */     if (tree != null) {
/*  970 */       for (Element subelement : tree.elements()) {
/*  971 */         if (this.propertyName.equals(subelement.attributeValue("method-name"))) {
/*  972 */           this.elementsForProperty.add(subelement);
/*      */         }
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */   private void getId(List<Annotation> annotationList, XMLContext.Default defaults) {
/*  979 */     for (Element element : this.elementsForProperty) {
/*  980 */       if ("id".equals(element.getName())) {
/*  981 */         boolean processId = isProcessingId(defaults);
/*  982 */         if (processId) {
/*  983 */           Annotation annotation = buildColumns(element);
/*  984 */           addIfNotNull(annotationList, annotation);
/*  985 */           annotation = buildGeneratedValue(element);
/*  986 */           addIfNotNull(annotationList, annotation);
/*  987 */           getTemporal(annotationList, element);
/*      */           
/*  989 */           annotation = getTableGenerator(element, defaults);
/*  990 */           addIfNotNull(annotationList, annotation);
/*  991 */           annotation = getSequenceGenerator(element, defaults);
/*  992 */           addIfNotNull(annotationList, annotation);
/*  993 */           AnnotationDescriptor id = new AnnotationDescriptor(Id.class);
/*  994 */           annotationList.add(AnnotationFactory.create(id));
/*      */         }
/*      */       }
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/* 1011 */     if ((this.elementsForProperty.size() == 0) && (defaults.canUseJavaAnnotations())) {
/* 1012 */       Annotation annotation = getJavaAnnotation(Id.class);
/* 1013 */       if (annotation != null) {
/* 1014 */         annotationList.add(annotation);
/* 1015 */         annotation = getJavaAnnotation(Column.class);
/* 1016 */         addIfNotNull(annotationList, annotation);
/* 1017 */         annotation = getJavaAnnotation(Columns.class);
/* 1018 */         addIfNotNull(annotationList, annotation);
/* 1019 */         annotation = getJavaAnnotation(GeneratedValue.class);
/* 1020 */         addIfNotNull(annotationList, annotation);
/* 1021 */         annotation = getJavaAnnotation(Temporal.class);
/* 1022 */         addIfNotNull(annotationList, annotation);
/* 1023 */         annotation = getJavaAnnotation(TableGenerator.class);
/* 1024 */         addIfNotNull(annotationList, annotation);
/* 1025 */         annotation = getJavaAnnotation(SequenceGenerator.class);
/* 1026 */         addIfNotNull(annotationList, annotation);
/* 1027 */         annotation = getJavaAnnotation(AttributeOverride.class);
/* 1028 */         addIfNotNull(annotationList, annotation);
/* 1029 */         annotation = getJavaAnnotation(AttributeOverrides.class);
/* 1030 */         addIfNotNull(annotationList, annotation);
/* 1031 */         annotation = getJavaAnnotation(AssociationOverride.class);
/* 1032 */         addIfNotNull(annotationList, annotation);
/* 1033 */         annotation = getJavaAnnotation(AssociationOverrides.class);
/* 1034 */         addIfNotNull(annotationList, annotation);
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */   private boolean isProcessingId(XMLContext.Default defaults) {
/* 1040 */     boolean isExplicit = defaults.getAccess() != null;
/* 1041 */     boolean correctAccess = ((PropertyType.PROPERTY.equals(this.propertyType)) && ("property".equals(defaults.getAccess()))) || ((PropertyType.FIELD.equals(this.propertyType)) && ("field".equals(defaults.getAccess())));
/*      */     
/*      */ 
/* 1044 */     boolean hasId = (defaults.canUseJavaAnnotations()) && ((isJavaAnnotationPresent(Id.class)) || (isJavaAnnotationPresent(EmbeddedId.class)));
/*      */     
/*      */ 
/* 1047 */     boolean mirrorAttributeIsId = (defaults.canUseJavaAnnotations()) && (this.mirroredAttribute != null) && ((this.mirroredAttribute.isAnnotationPresent(Id.class)) || (this.mirroredAttribute.isAnnotationPresent(EmbeddedId.class)));
/*      */     
/*      */ 
/*      */ 
/* 1051 */     boolean propertyIsDefault = (PropertyType.PROPERTY.equals(this.propertyType)) && (!mirrorAttributeIsId);
/*      */     
/* 1053 */     return (correctAccess) || ((!isExplicit) && (hasId)) || ((!isExplicit) && (propertyIsDefault));
/*      */   }
/*      */   
/*      */   private Columns buildColumns(Element element) {
/* 1057 */     List<Element> subelements = element.elements("column");
/* 1058 */     List<Column> columns = new ArrayList(subelements.size());
/* 1059 */     for (Element subelement : subelements) {
/* 1060 */       columns.add(getColumn(subelement, false, element));
/*      */     }
/* 1062 */     if (columns.size() > 0) {
/* 1063 */       AnnotationDescriptor columnsDescr = new AnnotationDescriptor(Columns.class);
/* 1064 */       columnsDescr.setValue("columns", columns.toArray(new Column[columns.size()]));
/* 1065 */       return (Columns)AnnotationFactory.create(columnsDescr);
/*      */     }
/*      */     
/* 1068 */     return null;
/*      */   }
/*      */   
/*      */   private GeneratedValue buildGeneratedValue(Element element)
/*      */   {
/* 1073 */     Element subElement = element != null ? element.element("generated-value") : null;
/* 1074 */     if (subElement != null) {
/* 1075 */       AnnotationDescriptor ad = new AnnotationDescriptor(GeneratedValue.class);
/* 1076 */       String strategy = subElement.attributeValue("strategy");
/* 1077 */       if ("TABLE".equalsIgnoreCase(strategy)) {
/* 1078 */         ad.setValue("strategy", GenerationType.TABLE);
/*      */       }
/* 1080 */       else if ("SEQUENCE".equalsIgnoreCase(strategy)) {
/* 1081 */         ad.setValue("strategy", GenerationType.SEQUENCE);
/*      */       }
/* 1083 */       else if ("IDENTITY".equalsIgnoreCase(strategy)) {
/* 1084 */         ad.setValue("strategy", GenerationType.IDENTITY);
/*      */       }
/* 1086 */       else if ("AUTO".equalsIgnoreCase(strategy)) {
/* 1087 */         ad.setValue("strategy", GenerationType.AUTO);
/*      */       }
/* 1089 */       else if (StringHelper.isNotEmpty(strategy)) {
/* 1090 */         throw new AnnotationException("Unknown GenerationType: " + strategy + ". " + "Activate schema validation for more informations");
/*      */       }
/* 1092 */       copyStringAttribute(ad, subElement, "generator", false);
/* 1093 */       return (GeneratedValue)AnnotationFactory.create(ad);
/*      */     }
/*      */     
/* 1096 */     return null;
/*      */   }
/*      */   
/*      */   private void getTemporal(List<Annotation> annotationList, Element element)
/*      */   {
/* 1101 */     Element subElement = element != null ? element.element("temporal") : null;
/* 1102 */     if (subElement != null) {
/* 1103 */       AnnotationDescriptor ad = new AnnotationDescriptor(Temporal.class);
/* 1104 */       String temporal = subElement.getTextTrim();
/* 1105 */       if ("DATE".equalsIgnoreCase(temporal)) {
/* 1106 */         ad.setValue("value", TemporalType.DATE);
/*      */       }
/* 1108 */       else if ("TIME".equalsIgnoreCase(temporal)) {
/* 1109 */         ad.setValue("value", TemporalType.TIME);
/*      */       }
/* 1111 */       else if ("TIMESTAMP".equalsIgnoreCase(temporal)) {
/* 1112 */         ad.setValue("value", TemporalType.TIMESTAMP);
/*      */       }
/* 1114 */       else if (StringHelper.isNotEmpty(temporal)) {
/* 1115 */         throw new AnnotationException("Unknown TemporalType: " + temporal + ". " + "Activate schema validation for more informations");
/*      */       }
/* 1117 */       annotationList.add(AnnotationFactory.create(ad));
/*      */     }
/*      */   }
/*      */   
/*      */   private AssociationOverrides getAssociationOverrides(Element tree, XMLContext.Default defaults) {
/* 1122 */     List<AssociationOverride> attributes = buildAssociationOverrides(tree);
/* 1123 */     if (defaults.canUseJavaAnnotations()) {
/* 1124 */       AssociationOverride annotation = (AssociationOverride)getJavaAnnotation(AssociationOverride.class);
/* 1125 */       addAssociationOverrideIfNeeded(annotation, attributes);
/* 1126 */       AssociationOverrides annotations = (AssociationOverrides)getJavaAnnotation(AssociationOverrides.class);
/* 1127 */       if (annotations != null) {
/* 1128 */         for (AssociationOverride current : annotations.value()) {
/* 1129 */           addAssociationOverrideIfNeeded(current, attributes);
/*      */         }
/*      */       }
/*      */     }
/* 1133 */     if (attributes.size() > 0) {
/* 1134 */       AnnotationDescriptor ad = new AnnotationDescriptor(AssociationOverrides.class);
/* 1135 */       ad.setValue("value", attributes.toArray(new AssociationOverride[attributes.size()]));
/* 1136 */       return (AssociationOverrides)AnnotationFactory.create(ad);
/*      */     }
/*      */     
/* 1139 */     return null;
/*      */   }
/*      */   
/*      */   private List<AssociationOverride> buildAssociationOverrides(Element element)
/*      */   {
/* 1144 */     List<Element> subelements = element == null ? null : element.elements("association-override");
/* 1145 */     List<AssociationOverride> overrides = new ArrayList();
/* 1146 */     if ((subelements != null) && (subelements.size() > 0)) {
/* 1147 */       for (Element current : subelements) {
/* 1148 */         AnnotationDescriptor override = new AnnotationDescriptor(AssociationOverride.class);
/* 1149 */         copyStringAttribute(override, current, "name", true);
/* 1150 */         override.setValue("joinColumns", getJoinColumns(current, false));
/* 1151 */         overrides.add((AssociationOverride)AnnotationFactory.create(override));
/*      */       }
/*      */     }
/* 1154 */     return overrides;
/*      */   }
/*      */   
/*      */   private JoinColumn[] getJoinColumns(Element element, boolean isInverse) {
/* 1158 */     List<Element> subelements = element != null ? element.elements(isInverse ? "inverse-join-column" : "join-column") : null;
/*      */     
/*      */ 
/* 1161 */     List<JoinColumn> joinColumns = new ArrayList();
/* 1162 */     if (subelements != null) {
/* 1163 */       for (Element subelement : subelements) {
/* 1164 */         AnnotationDescriptor column = new AnnotationDescriptor(JoinColumn.class);
/* 1165 */         copyStringAttribute(column, subelement, "name", false);
/* 1166 */         copyStringAttribute(column, subelement, "referenced-column-name", false);
/* 1167 */         copyBooleanAttribute(column, subelement, "unique");
/* 1168 */         copyBooleanAttribute(column, subelement, "nullable");
/* 1169 */         copyBooleanAttribute(column, subelement, "insertable");
/* 1170 */         copyBooleanAttribute(column, subelement, "updatable");
/* 1171 */         copyStringAttribute(column, subelement, "column-definition", false);
/* 1172 */         copyStringAttribute(column, subelement, "table", false);
/* 1173 */         joinColumns.add((JoinColumn)AnnotationFactory.create(column));
/*      */       }
/*      */     }
/* 1176 */     return (JoinColumn[])joinColumns.toArray(new JoinColumn[joinColumns.size()]);
/*      */   }
/*      */   
/*      */   private void addAssociationOverrideIfNeeded(AssociationOverride annotation, List<AssociationOverride> overrides) {
/* 1180 */     if (annotation != null) {
/* 1181 */       String overrideName = annotation.name();
/* 1182 */       boolean present = false;
/* 1183 */       for (AssociationOverride current : overrides) {
/* 1184 */         if (current.name().equals(overrideName)) {
/* 1185 */           present = true;
/* 1186 */           break;
/*      */         }
/*      */       }
/* 1189 */       if (!present) overrides.add(annotation);
/*      */     }
/*      */   }
/*      */   
/*      */   private AttributeOverrides getAttributeOverrides(Element tree, XMLContext.Default defaults) {
/* 1194 */     List<AttributeOverride> attributes = buildAttributeOverrides(tree);
/* 1195 */     return mergeAttributeOverrides(defaults, attributes);
/*      */   }
/*      */   
/*      */   private AttributeOverrides getAttributeOverrides(List<Element> elements, XMLContext.Default defaults) {
/* 1199 */     List<AttributeOverride> attributes = new ArrayList();
/* 1200 */     for (Element element : elements) {
/* 1201 */       attributes.addAll(buildAttributeOverrides(element));
/*      */     }
/* 1203 */     return mergeAttributeOverrides(defaults, attributes);
/*      */   }
/*      */   
/*      */   private AttributeOverrides mergeAttributeOverrides(XMLContext.Default defaults, List<AttributeOverride> attributes)
/*      */   {
/* 1208 */     if (defaults.canUseJavaAnnotations()) {
/* 1209 */       AttributeOverride annotation = (AttributeOverride)getJavaAnnotation(AttributeOverride.class);
/* 1210 */       addAttributeOverrideIfNeeded(annotation, attributes);
/* 1211 */       AttributeOverrides annotations = (AttributeOverrides)getJavaAnnotation(AttributeOverrides.class);
/* 1212 */       if (annotations != null) {
/* 1213 */         for (AttributeOverride current : annotations.value()) {
/* 1214 */           addAttributeOverrideIfNeeded(current, attributes);
/*      */         }
/*      */       }
/*      */     }
/* 1218 */     if (attributes.size() > 0) {
/* 1219 */       AnnotationDescriptor ad = new AnnotationDescriptor(AttributeOverrides.class);
/* 1220 */       ad.setValue("value", attributes.toArray(new AttributeOverride[attributes.size()]));
/* 1221 */       return (AttributeOverrides)AnnotationFactory.create(ad);
/*      */     }
/*      */     
/* 1224 */     return null;
/*      */   }
/*      */   
/*      */   private List<AttributeOverride> buildAttributeOverrides(Element element)
/*      */   {
/* 1229 */     List<Element> subelements = element == null ? null : element.elements("attribute-override");
/* 1230 */     return buildAttributeOverrides(subelements);
/*      */   }
/*      */   
/*      */   private List<AttributeOverride> buildAttributeOverrides(List<Element> subelements) {
/* 1234 */     List<AttributeOverride> overrides = new ArrayList();
/* 1235 */     if ((subelements != null) && (subelements.size() > 0)) {
/* 1236 */       for (Element current : subelements)
/* 1237 */         if (current.getName().equals("attribute-override")) {
/* 1238 */           AnnotationDescriptor override = new AnnotationDescriptor(AttributeOverride.class);
/* 1239 */           copyStringAttribute(override, current, "name", true);
/* 1240 */           Element column = current != null ? current.element("column") : null;
/* 1241 */           override.setValue("column", getColumn(column, true, current));
/* 1242 */           overrides.add((AttributeOverride)AnnotationFactory.create(override));
/*      */         }
/*      */     }
/* 1245 */     return overrides;
/*      */   }
/*      */   
/*      */   private Column getColumn(Element element, boolean isMandatory, Element current)
/*      */   {
/* 1250 */     if (element != null) {
/* 1251 */       AnnotationDescriptor column = new AnnotationDescriptor(Column.class);
/* 1252 */       copyStringAttribute(column, element, "name", false);
/* 1253 */       copyBooleanAttribute(column, element, "unique");
/* 1254 */       copyBooleanAttribute(column, element, "nullable");
/* 1255 */       copyBooleanAttribute(column, element, "insertable");
/* 1256 */       copyBooleanAttribute(column, element, "updatable");
/* 1257 */       copyStringAttribute(column, element, "column-definition", false);
/* 1258 */       copyStringAttribute(column, element, "table", false);
/* 1259 */       copyIntegerAttribute(column, element, "length");
/* 1260 */       copyIntegerAttribute(column, element, "precision");
/* 1261 */       copyIntegerAttribute(column, element, "scale");
/* 1262 */       return (Column)AnnotationFactory.create(column);
/*      */     }
/*      */     
/* 1265 */     if (isMandatory) {
/* 1266 */       throw new AnnotationException(current.getPath() + ".column is mandatory. " + "Activate schema validation for more informations");
/*      */     }
/* 1268 */     return null;
/*      */   }
/*      */   
/*      */   private void addAttributeOverrideIfNeeded(AttributeOverride annotation, List<AttributeOverride> overrides)
/*      */   {
/* 1273 */     if (annotation != null) {
/* 1274 */       String overrideName = annotation.name();
/* 1275 */       boolean present = false;
/* 1276 */       for (AttributeOverride current : overrides) {
/* 1277 */         if (current.name().equals(overrideName)) {
/* 1278 */           present = true;
/* 1279 */           break;
/*      */         }
/*      */       }
/* 1282 */       if (!present) overrides.add(annotation);
/*      */     }
/*      */   }
/*      */   
/*      */   private AccessType getAccessType(Element tree, XMLContext.Default defaults) {
/* 1287 */     String access = tree == null ? null : tree.attributeValue("access");
/* 1288 */     if (("FIELD".equals(access)) || ("PROPERTY".equals(access))) {
/* 1289 */       access = access.toLowerCase();
/*      */     }
/* 1291 */     if (access != null) {
/* 1292 */       AnnotationDescriptor ad = new AnnotationDescriptor(AccessType.class);
/* 1293 */       ad.setValue("value", access);
/* 1294 */       return (AccessType)AnnotationFactory.create(ad);
/*      */     }
/* 1296 */     if ((defaults.canUseJavaAnnotations()) && (isJavaAnnotationPresent(AccessType.class))) {
/* 1297 */       AccessType annotation = (AccessType)getJavaAnnotation(AccessType.class);
/* 1298 */       return annotation;
/*      */     }
/* 1300 */     if (defaults.getAccess() != null) {
/* 1301 */       AnnotationDescriptor ad = new AnnotationDescriptor(AccessType.class);
/* 1302 */       ad.setValue("value", defaults.getAccess());
/* 1303 */       return (AccessType)AnnotationFactory.create(ad);
/*      */     }
/*      */     
/* 1306 */     return null;
/*      */   }
/*      */   
/*      */   private ExcludeSuperclassListeners getExcludeSuperclassListeners(Element tree, XMLContext.Default defaults)
/*      */   {
/* 1311 */     return (ExcludeSuperclassListeners)getMarkerAnnotation(ExcludeSuperclassListeners.class, tree, defaults);
/*      */   }
/*      */   
/*      */   private ExcludeDefaultListeners getExcludeDefaultListeners(Element tree, XMLContext.Default defaults) {
/* 1315 */     return (ExcludeDefaultListeners)getMarkerAnnotation(ExcludeDefaultListeners.class, tree, defaults);
/*      */   }
/*      */   
/*      */ 
/*      */   private Annotation getMarkerAnnotation(Class<? extends Annotation> clazz, Element element, XMLContext.Default defaults)
/*      */   {
/* 1321 */     Element subelement = element == null ? null : element.element((String)annotationToXml.get(clazz));
/* 1322 */     if (subelement != null) {
/* 1323 */       return AnnotationFactory.create(new AnnotationDescriptor(clazz));
/*      */     }
/* 1325 */     if (defaults.canUseJavaAnnotations())
/*      */     {
/* 1327 */       return getJavaAnnotation(clazz);
/*      */     }
/*      */     
/* 1330 */     return null;
/*      */   }
/*      */   
/*      */   private SqlResultSetMappings getSqlResultSetMappings(Element tree, XMLContext.Default defaults)
/*      */   {
/* 1335 */     List<SqlResultSetMapping> results = buildSqlResultsetMappings(tree, defaults);
/* 1336 */     if (defaults.canUseJavaAnnotations()) {
/* 1337 */       SqlResultSetMapping annotation = (SqlResultSetMapping)getJavaAnnotation(SqlResultSetMapping.class);
/* 1338 */       addSqlResultsetMappingIfNeeded(annotation, results);
/* 1339 */       SqlResultSetMappings annotations = (SqlResultSetMappings)getJavaAnnotation(SqlResultSetMappings.class);
/* 1340 */       if (annotations != null) {
/* 1341 */         for (SqlResultSetMapping current : annotations.value()) {
/* 1342 */           addSqlResultsetMappingIfNeeded(current, results);
/*      */         }
/*      */       }
/*      */     }
/* 1346 */     if (results.size() > 0) {
/* 1347 */       AnnotationDescriptor ad = new AnnotationDescriptor(SqlResultSetMappings.class);
/* 1348 */       ad.setValue("value", results.toArray(new SqlResultSetMapping[results.size()]));
/* 1349 */       return (SqlResultSetMappings)AnnotationFactory.create(ad);
/*      */     }
/*      */     
/* 1352 */     return null;
/*      */   }
/*      */   
/*      */   public static List<SqlResultSetMapping> buildSqlResultsetMappings(Element element, XMLContext.Default defaults)
/*      */   {
/* 1357 */     if (element == null) return new ArrayList();
/* 1358 */     List resultsetElementList = element.elements("sql-result-set-mapping");
/* 1359 */     List<SqlResultSetMapping> resultsets = new ArrayList();
/* 1360 */     Iterator it = resultsetElementList.listIterator();
/* 1361 */     while (it.hasNext()) {
/* 1362 */       Element subelement = (Element)it.next();
/* 1363 */       AnnotationDescriptor ann = new AnnotationDescriptor(SqlResultSetMapping.class);
/* 1364 */       copyStringAttribute(ann, subelement, "name", true);
/* 1365 */       List<Element> elements = subelement.elements("entity-result");
/* 1366 */       List<EntityResult> entityResults = new ArrayList(elements.size());
/* 1367 */       for (Element entityResult : elements) {
/* 1368 */         AnnotationDescriptor entityResultDescriptor = new AnnotationDescriptor(EntityResult.class);
/* 1369 */         String clazzName = entityResult.attributeValue("entity-class");
/* 1370 */         if (clazzName == null) {
/* 1371 */           throw new AnnotationException("<entity-result> without entity-class. Activate schema validation for more informations");
/*      */         }
/* 1373 */         Class clazz = null;
/*      */         try {
/* 1375 */           clazz = ReflectHelper.classForName(XMLContext.buildSafeClassName(clazzName, defaults), EJB3OverridenAnnotationReader.class);
/*      */ 
/*      */         }
/*      */         catch (ClassNotFoundException e)
/*      */         {
/*      */ 
/* 1381 */           throw new AnnotationException("Unable to find entity-class: " + clazzName, e);
/*      */         }
/* 1383 */         entityResultDescriptor.setValue("entityClass", clazz);
/* 1384 */         copyStringAttribute(entityResultDescriptor, entityResult, "discriminator-column", false);
/* 1385 */         List<FieldResult> fieldResults = new ArrayList();
/* 1386 */         for (Element fieldResult : entityResult.elements("field-result")) {
/* 1387 */           AnnotationDescriptor fieldResultDescriptor = new AnnotationDescriptor(FieldResult.class);
/* 1388 */           copyStringAttribute(fieldResultDescriptor, fieldResult, "name", true);
/* 1389 */           copyStringAttribute(fieldResultDescriptor, fieldResult, "column", true);
/* 1390 */           fieldResults.add((FieldResult)AnnotationFactory.create(fieldResultDescriptor));
/*      */         }
/* 1392 */         entityResultDescriptor.setValue("fields", fieldResults.toArray(new FieldResult[fieldResults.size()]));
/*      */         
/*      */ 
/* 1395 */         entityResults.add((EntityResult)AnnotationFactory.create(entityResultDescriptor));
/*      */       }
/* 1397 */       ann.setValue("entities", entityResults.toArray(new EntityResult[entityResults.size()]));
/*      */       
/* 1399 */       elements = subelement.elements("column-result");
/* 1400 */       List<ColumnResult> columnResults = new ArrayList(elements.size());
/* 1401 */       for (Element columnResult : elements) {
/* 1402 */         AnnotationDescriptor columnResultDescriptor = new AnnotationDescriptor(ColumnResult.class);
/* 1403 */         copyStringAttribute(columnResultDescriptor, columnResult, "name", true);
/* 1404 */         columnResults.add((ColumnResult)AnnotationFactory.create(columnResultDescriptor));
/*      */       }
/* 1406 */       ann.setValue("columns", columnResults.toArray(new ColumnResult[columnResults.size()]));
/*      */       
/* 1408 */       String clazzName = subelement.attributeValue("result-class");
/* 1409 */       if (StringHelper.isNotEmpty(clazzName)) {
/* 1410 */         Class clazz = null;
/*      */         try {
/* 1412 */           clazz = ReflectHelper.classForName(XMLContext.buildSafeClassName(clazzName, defaults), EJB3OverridenAnnotationReader.class);
/*      */ 
/*      */         }
/*      */         catch (ClassNotFoundException e)
/*      */         {
/*      */ 
/* 1418 */           throw new AnnotationException("Unable to find entity-class: " + clazzName, e);
/*      */         }
/* 1420 */         ann.setValue("resultClass", clazz);
/*      */       }
/* 1422 */       copyStringAttribute(ann, subelement, "result-set-mapping", false);
/* 1423 */       resultsets.add((SqlResultSetMapping)AnnotationFactory.create(ann));
/*      */     }
/* 1425 */     return resultsets;
/*      */   }
/*      */   
/*      */   private void addSqlResultsetMappingIfNeeded(SqlResultSetMapping annotation, List<SqlResultSetMapping> resultsets) {
/* 1429 */     if (annotation != null) {
/* 1430 */       String resultsetName = annotation.name();
/* 1431 */       boolean present = false;
/* 1432 */       for (SqlResultSetMapping current : resultsets) {
/* 1433 */         if (current.name().equals(resultsetName)) {
/* 1434 */           present = true;
/* 1435 */           break;
/*      */         }
/*      */       }
/* 1438 */       if (!present) resultsets.add(annotation);
/*      */     }
/*      */   }
/*      */   
/*      */   private NamedQueries getNamedQueries(Element tree, XMLContext.Default defaults)
/*      */   {
/* 1444 */     List<NamedQuery> queries = buildNamedQueries(tree, false, defaults);
/* 1445 */     if (defaults.canUseJavaAnnotations()) {
/* 1446 */       NamedQuery annotation = (NamedQuery)getJavaAnnotation(NamedQuery.class);
/* 1447 */       addNamedQueryIfNeeded(annotation, queries);
/* 1448 */       NamedQueries annotations = (NamedQueries)getJavaAnnotation(NamedQueries.class);
/* 1449 */       if (annotations != null) {
/* 1450 */         for (NamedQuery current : annotations.value()) {
/* 1451 */           addNamedQueryIfNeeded(current, queries);
/*      */         }
/*      */       }
/*      */     }
/* 1455 */     if (queries.size() > 0) {
/* 1456 */       AnnotationDescriptor ad = new AnnotationDescriptor(NamedQueries.class);
/* 1457 */       ad.setValue("value", queries.toArray(new NamedQuery[queries.size()]));
/* 1458 */       return (NamedQueries)AnnotationFactory.create(ad);
/*      */     }
/*      */     
/* 1461 */     return null;
/*      */   }
/*      */   
/*      */   private void addNamedQueryIfNeeded(NamedQuery annotation, List<NamedQuery> queries)
/*      */   {
/* 1466 */     if (annotation != null) {
/* 1467 */       String queryName = annotation.name();
/* 1468 */       boolean present = false;
/* 1469 */       for (NamedQuery current : queries) {
/* 1470 */         if (current.name().equals(queryName)) {
/* 1471 */           present = true;
/* 1472 */           break;
/*      */         }
/*      */       }
/* 1475 */       if (!present) queries.add(annotation);
/*      */     }
/*      */   }
/*      */   
/*      */   private NamedNativeQueries getNamedNativeQueries(Element tree, XMLContext.Default defaults) {
/* 1480 */     List<NamedNativeQuery> queries = buildNamedQueries(tree, true, defaults);
/* 1481 */     if (defaults.canUseJavaAnnotations()) {
/* 1482 */       NamedNativeQuery annotation = (NamedNativeQuery)getJavaAnnotation(NamedNativeQuery.class);
/* 1483 */       addNamedNativeQueryIfNeeded(annotation, queries);
/* 1484 */       NamedNativeQueries annotations = (NamedNativeQueries)getJavaAnnotation(NamedNativeQueries.class);
/* 1485 */       if (annotations != null) {
/* 1486 */         for (NamedNativeQuery current : annotations.value()) {
/* 1487 */           addNamedNativeQueryIfNeeded(current, queries);
/*      */         }
/*      */       }
/*      */     }
/* 1491 */     if (queries.size() > 0) {
/* 1492 */       AnnotationDescriptor ad = new AnnotationDescriptor(NamedNativeQueries.class);
/* 1493 */       ad.setValue("value", queries.toArray(new NamedNativeQuery[queries.size()]));
/* 1494 */       return (NamedNativeQueries)AnnotationFactory.create(ad);
/*      */     }
/*      */     
/* 1497 */     return null;
/*      */   }
/*      */   
/*      */   private void addNamedNativeQueryIfNeeded(NamedNativeQuery annotation, List<NamedNativeQuery> queries)
/*      */   {
/* 1502 */     if (annotation != null) {
/* 1503 */       String queryName = annotation.name();
/* 1504 */       boolean present = false;
/* 1505 */       for (NamedNativeQuery current : queries) {
/* 1506 */         if (current.name().equals(queryName)) {
/* 1507 */           present = true;
/* 1508 */           break;
/*      */         }
/*      */       }
/* 1511 */       if (!present) queries.add(annotation);
/*      */     }
/*      */   }
/*      */   
/*      */   public static List buildNamedQueries(Element element, boolean isNative, XMLContext.Default defaults) {
/* 1516 */     if (element == null) return new ArrayList();
/* 1517 */     List namedQueryElementList = isNative ? element.elements("named-native-query") : element.elements("named-query");
/*      */     
/*      */ 
/* 1520 */     List namedQueries = new ArrayList();
/* 1521 */     Iterator it = namedQueryElementList.listIterator();
/* 1522 */     while (it.hasNext()) {
/* 1523 */       Element subelement = (Element)it.next();
/* 1524 */       AnnotationDescriptor ann = new AnnotationDescriptor(isNative ? NamedNativeQuery.class : NamedQuery.class);
/*      */       
/*      */ 
/* 1527 */       copyStringAttribute(ann, subelement, "name", false);
/* 1528 */       Element queryElt = subelement.element("query");
/* 1529 */       if (queryElt == null) throw new AnnotationException("No <query> element found.Activate schema validation for more informations");
/* 1530 */       ann.setValue("query", queryElt.getTextTrim());
/* 1531 */       List<Element> elements = subelement.elements("hint");
/* 1532 */       List<QueryHint> queryHints = new ArrayList(elements.size());
/* 1533 */       for (Element hint : elements) {
/* 1534 */         AnnotationDescriptor hintDescriptor = new AnnotationDescriptor(QueryHint.class);
/* 1535 */         String value = hint.attributeValue("name");
/* 1536 */         if (value == null) throw new AnnotationException("<hint> without name. Activate schema validation for more informations");
/* 1537 */         hintDescriptor.setValue("name", value);
/* 1538 */         value = hint.attributeValue("value");
/* 1539 */         if (value == null) throw new AnnotationException("<hint> without value. Activate schema validation for more informations");
/* 1540 */         hintDescriptor.setValue("value", value);
/* 1541 */         queryHints.add((QueryHint)AnnotationFactory.create(hintDescriptor));
/*      */       }
/* 1543 */       ann.setValue("hints", queryHints.toArray(new QueryHint[queryHints.size()]));
/* 1544 */       String clazzName = subelement.attributeValue("result-class");
/* 1545 */       if (StringHelper.isNotEmpty(clazzName)) {
/* 1546 */         Class clazz = null;
/*      */         try {
/* 1548 */           clazz = ReflectHelper.classForName(XMLContext.buildSafeClassName(clazzName, defaults), EJB3OverridenAnnotationReader.class);
/*      */ 
/*      */         }
/*      */         catch (ClassNotFoundException e)
/*      */         {
/*      */ 
/* 1554 */           throw new AnnotationException("Unable to find entity-class: " + clazzName, e);
/*      */         }
/* 1556 */         ann.setValue("resultClass", clazz);
/*      */       }
/* 1558 */       copyStringAttribute(ann, subelement, "result-set-mapping", false);
/* 1559 */       namedQueries.add(AnnotationFactory.create(ann));
/*      */     }
/* 1561 */     return namedQueries;
/*      */   }
/*      */   
/*      */   private TableGenerator getTableGenerator(Element tree, XMLContext.Default defaults) {
/* 1565 */     Element element = tree != null ? tree.element((String)annotationToXml.get(TableGenerator.class)) : null;
/* 1566 */     if (element != null) {
/* 1567 */       return buildTableGeneratorAnnotation(element, defaults);
/*      */     }
/* 1569 */     if ((defaults.canUseJavaAnnotations()) && (isJavaAnnotationPresent(TableGenerator.class))) {
/* 1570 */       TableGenerator tableAnn = (TableGenerator)getJavaAnnotation(TableGenerator.class);
/* 1571 */       if ((StringHelper.isNotEmpty(defaults.getSchema())) || (StringHelper.isNotEmpty(defaults.getCatalog())))
/*      */       {
/* 1573 */         AnnotationDescriptor annotation = new AnnotationDescriptor(TableGenerator.class);
/* 1574 */         annotation.setValue("name", tableAnn.name());
/* 1575 */         annotation.setValue("table", tableAnn.table());
/* 1576 */         annotation.setValue("catalog", tableAnn.table());
/* 1577 */         if ((StringHelper.isEmpty((String)annotation.valueOf("catalog"))) && (StringHelper.isNotEmpty(defaults.getCatalog())))
/*      */         {
/* 1579 */           annotation.setValue("catalog", defaults.getCatalog());
/*      */         }
/* 1581 */         annotation.setValue("schema", tableAnn.table());
/* 1582 */         if ((StringHelper.isEmpty((String)annotation.valueOf("schema"))) && (StringHelper.isNotEmpty(defaults.getSchema())))
/*      */         {
/* 1584 */           annotation.setValue("catalog", defaults.getSchema());
/*      */         }
/* 1586 */         annotation.setValue("pkColumnName", tableAnn.pkColumnName());
/* 1587 */         annotation.setValue("valueColumnName", tableAnn.valueColumnName());
/* 1588 */         annotation.setValue("pkColumnValue", tableAnn.pkColumnValue());
/* 1589 */         annotation.setValue("initialValue", Integer.valueOf(tableAnn.initialValue()));
/* 1590 */         annotation.setValue("allocationSize", Integer.valueOf(tableAnn.allocationSize()));
/* 1591 */         annotation.setValue("uniqueConstraints", tableAnn.uniqueConstraints());
/* 1592 */         return (TableGenerator)AnnotationFactory.create(annotation);
/*      */       }
/*      */       
/* 1595 */       return tableAnn;
/*      */     }
/*      */     
/*      */ 
/* 1599 */     return null;
/*      */   }
/*      */   
/*      */   public static TableGenerator buildTableGeneratorAnnotation(Element element, XMLContext.Default defaults)
/*      */   {
/* 1604 */     AnnotationDescriptor ad = new AnnotationDescriptor(TableGenerator.class);
/* 1605 */     copyStringAttribute(ad, element, "name", false);
/* 1606 */     copyStringAttribute(ad, element, "table", false);
/* 1607 */     copyStringAttribute(ad, element, "catalog", false);
/* 1608 */     copyStringAttribute(ad, element, "schema", false);
/* 1609 */     copyStringAttribute(ad, element, "pk-column-name", false);
/* 1610 */     copyStringAttribute(ad, element, "value-column-name", false);
/* 1611 */     copyStringAttribute(ad, element, "pk-column-value", false);
/* 1612 */     copyIntegerAttribute(ad, element, "initial-value");
/* 1613 */     copyIntegerAttribute(ad, element, "allocation-size");
/* 1614 */     buildUniqueConstraints(ad, element);
/* 1615 */     if ((StringHelper.isEmpty((String)ad.valueOf("schema"))) && (StringHelper.isNotEmpty(defaults.getSchema())))
/*      */     {
/* 1617 */       ad.setValue("schema", defaults.getSchema());
/*      */     }
/* 1619 */     if ((StringHelper.isEmpty((String)ad.valueOf("catalog"))) && (StringHelper.isNotEmpty(defaults.getCatalog())))
/*      */     {
/* 1621 */       ad.setValue("catalog", defaults.getCatalog());
/*      */     }
/* 1623 */     return (TableGenerator)AnnotationFactory.create(ad);
/*      */   }
/*      */   
/*      */   private SequenceGenerator getSequenceGenerator(Element tree, XMLContext.Default defaults) {
/* 1627 */     Element element = tree != null ? tree.element((String)annotationToXml.get(SequenceGenerator.class)) : null;
/* 1628 */     if (element != null) {
/* 1629 */       return buildSequenceGeneratorAnnotation(element);
/*      */     }
/* 1631 */     if (defaults.canUseJavaAnnotations()) {
/* 1632 */       return (SequenceGenerator)getJavaAnnotation(SequenceGenerator.class);
/*      */     }
/*      */     
/* 1635 */     return null;
/*      */   }
/*      */   
/*      */   public static SequenceGenerator buildSequenceGeneratorAnnotation(Element element)
/*      */   {
/* 1640 */     if (element != null) {
/* 1641 */       AnnotationDescriptor ad = new AnnotationDescriptor(SequenceGenerator.class);
/* 1642 */       copyStringAttribute(ad, element, "name", false);
/* 1643 */       copyStringAttribute(ad, element, "sequence-name", false);
/* 1644 */       copyIntegerAttribute(ad, element, "initial-value");
/* 1645 */       copyIntegerAttribute(ad, element, "allocation-size");
/* 1646 */       return (SequenceGenerator)AnnotationFactory.create(ad);
/*      */     }
/*      */     
/* 1649 */     return null;
/*      */   }
/*      */   
/*      */   private DiscriminatorColumn getDiscriminatorColumn(Element tree, XMLContext.Default defaults)
/*      */   {
/* 1654 */     Element element = tree != null ? tree.element("discriminator-column") : null;
/* 1655 */     if (element != null) {
/* 1656 */       AnnotationDescriptor ad = new AnnotationDescriptor(DiscriminatorColumn.class);
/* 1657 */       copyStringAttribute(ad, element, "name", false);
/* 1658 */       copyStringAttribute(ad, element, "column-definition", false);
/* 1659 */       String value = element.attributeValue("discriminator-type");
/* 1660 */       DiscriminatorType type = DiscriminatorType.STRING;
/* 1661 */       if (value != null) {
/* 1662 */         if ("STRING".equals(value)) {
/* 1663 */           type = DiscriminatorType.STRING;
/*      */         }
/* 1665 */         else if ("CHAR".equals(value)) {
/* 1666 */           type = DiscriminatorType.CHAR;
/*      */         }
/* 1668 */         else if ("INTEGER".equals(value)) {
/* 1669 */           type = DiscriminatorType.INTEGER;
/*      */         }
/*      */         else {
/* 1672 */           throw new AnnotationException("Unknown DiscrimiatorType in XML: " + value + " (" + "Activate schema validation for more informations" + ")");
/*      */         }
/*      */       }
/*      */       
/*      */ 
/* 1677 */       ad.setValue("discriminatorType", type);
/* 1678 */       copyIntegerAttribute(ad, element, "length");
/* 1679 */       return (DiscriminatorColumn)AnnotationFactory.create(ad);
/*      */     }
/* 1681 */     if (defaults.canUseJavaAnnotations()) {
/* 1682 */       return (DiscriminatorColumn)getJavaAnnotation(DiscriminatorColumn.class);
/*      */     }
/*      */     
/* 1685 */     return null;
/*      */   }
/*      */   
/*      */   private DiscriminatorValue getDiscriminatorValue(Element tree, XMLContext.Default defaults)
/*      */   {
/* 1690 */     Element element = tree != null ? tree.element("discriminator-value") : null;
/* 1691 */     if (element != null) {
/* 1692 */       AnnotationDescriptor ad = new AnnotationDescriptor(DiscriminatorValue.class);
/* 1693 */       copyStringElement(element, ad, "value");
/* 1694 */       return (DiscriminatorValue)AnnotationFactory.create(ad);
/*      */     }
/* 1696 */     if (defaults.canUseJavaAnnotations()) {
/* 1697 */       return (DiscriminatorValue)getJavaAnnotation(DiscriminatorValue.class);
/*      */     }
/*      */     
/* 1700 */     return null;
/*      */   }
/*      */   
/*      */   private Inheritance getInheritance(Element tree, XMLContext.Default defaults)
/*      */   {
/* 1705 */     Element element = tree != null ? tree.element("inheritance") : null;
/* 1706 */     if (element != null) {
/* 1707 */       AnnotationDescriptor ad = new AnnotationDescriptor(Inheritance.class);
/* 1708 */       Attribute attr = element.attribute("strategy");
/* 1709 */       InheritanceType strategy = InheritanceType.SINGLE_TABLE;
/* 1710 */       if (attr != null) {
/* 1711 */         String value = attr.getValue();
/* 1712 */         if ("SINGLE_TABLE".equals(value)) {
/* 1713 */           strategy = InheritanceType.SINGLE_TABLE;
/*      */         }
/* 1715 */         else if ("JOINED".equals(value)) {
/* 1716 */           strategy = InheritanceType.JOINED;
/*      */         }
/* 1718 */         else if ("TABLE_PER_CLASS".equals(value)) {
/* 1719 */           strategy = InheritanceType.TABLE_PER_CLASS;
/*      */         }
/*      */         else {
/* 1722 */           throw new AnnotationException("Unknown InheritanceType in XML: " + value + " (" + "Activate schema validation for more informations" + ")");
/*      */         }
/*      */       }
/*      */       
/*      */ 
/* 1727 */       ad.setValue("strategy", strategy);
/* 1728 */       return (Inheritance)AnnotationFactory.create(ad);
/*      */     }
/* 1730 */     if (defaults.canUseJavaAnnotations()) {
/* 1731 */       return (Inheritance)getJavaAnnotation(Inheritance.class);
/*      */     }
/*      */     
/* 1734 */     return null;
/*      */   }
/*      */   
/*      */   private IdClass getIdClass(Element tree, XMLContext.Default defaults)
/*      */   {
/* 1739 */     Element element = tree == null ? null : tree.element("id-class");
/* 1740 */     if (element != null) {
/* 1741 */       Attribute attr = element.attribute("class");
/* 1742 */       if (attr != null) {
/* 1743 */         AnnotationDescriptor ad = new AnnotationDescriptor(IdClass.class);
/* 1744 */         Class clazz = null;
/*      */         try {
/* 1746 */           clazz = ReflectHelper.classForName(XMLContext.buildSafeClassName(attr.getValue(), defaults), getClass());
/*      */ 
/*      */         }
/*      */         catch (ClassNotFoundException e)
/*      */         {
/*      */ 
/* 1752 */           throw new AnnotationException("Unable to find id-class: " + attr.getValue(), e);
/*      */         }
/* 1754 */         ad.setValue("value", clazz);
/* 1755 */         return (IdClass)AnnotationFactory.create(ad);
/*      */       }
/*      */       
/* 1758 */       throw new AnnotationException("id-class without class. Activate schema validation for more informations");
/*      */     }
/*      */     
/* 1761 */     if (defaults.canUseJavaAnnotations()) {
/* 1762 */       return (IdClass)getJavaAnnotation(IdClass.class);
/*      */     }
/*      */     
/* 1765 */     return null;
/*      */   }
/*      */   
/*      */   private PrimaryKeyJoinColumns getPrimaryKeyJoinColumns(Element element, XMLContext.Default defaults)
/*      */   {
/* 1770 */     PrimaryKeyJoinColumn[] columns = buildPrimaryKeyJoinColumns(element);
/* 1771 */     if ((columns.length == 0) && (defaults.canUseJavaAnnotations())) {
/* 1772 */       PrimaryKeyJoinColumn annotation = (PrimaryKeyJoinColumn)getJavaAnnotation(PrimaryKeyJoinColumn.class);
/* 1773 */       if (annotation != null) {
/* 1774 */         columns = new PrimaryKeyJoinColumn[] { annotation };
/*      */       }
/*      */       else {
/* 1777 */         PrimaryKeyJoinColumns annotations = (PrimaryKeyJoinColumns)getJavaAnnotation(PrimaryKeyJoinColumns.class);
/* 1778 */         columns = annotations != null ? annotations.value() : columns;
/*      */       }
/*      */     }
/* 1781 */     if (columns.length > 0) {
/* 1782 */       AnnotationDescriptor ad = new AnnotationDescriptor(PrimaryKeyJoinColumns.class);
/* 1783 */       ad.setValue("value", columns);
/* 1784 */       return (PrimaryKeyJoinColumns)AnnotationFactory.create(ad);
/*      */     }
/*      */     
/* 1787 */     return null;
/*      */   }
/*      */   
/*      */   private Entity getEntity(Element tree, XMLContext.Default defaults)
/*      */   {
/* 1792 */     if (tree == null) {
/* 1793 */       return defaults.canUseJavaAnnotations() ? (Entity)getJavaAnnotation(Entity.class) : null;
/*      */     }
/*      */     
/* 1796 */     if ("entity".equals(tree.getName())) {
/* 1797 */       AnnotationDescriptor entity = new AnnotationDescriptor(Entity.class);
/* 1798 */       copyStringAttribute(entity, tree, "name", false);
/* 1799 */       if ((defaults.canUseJavaAnnotations()) && (StringHelper.isEmpty((String)entity.valueOf("name"))))
/*      */       {
/* 1801 */         Entity javaAnn = (Entity)getJavaAnnotation(Entity.class);
/* 1802 */         if (javaAnn != null) entity.setValue("name", javaAnn.name());
/*      */       }
/* 1804 */       return (Entity)AnnotationFactory.create(entity);
/*      */     }
/*      */     
/* 1807 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */   private MappedSuperclass getMappedSuperclass(Element tree, XMLContext.Default defaults)
/*      */   {
/* 1813 */     if (tree == null) {
/* 1814 */       return defaults.canUseJavaAnnotations() ? (MappedSuperclass)getJavaAnnotation(MappedSuperclass.class) : null;
/*      */     }
/*      */     
/* 1817 */     if ("mapped-superclass".equals(tree.getName())) {
/* 1818 */       AnnotationDescriptor entity = new AnnotationDescriptor(MappedSuperclass.class);
/* 1819 */       return (MappedSuperclass)AnnotationFactory.create(entity);
/*      */     }
/*      */     
/* 1822 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */   private Embeddable getEmbeddable(Element tree, XMLContext.Default defaults)
/*      */   {
/* 1828 */     if (tree == null) {
/* 1829 */       return defaults.canUseJavaAnnotations() ? (Embeddable)getJavaAnnotation(Embeddable.class) : null;
/*      */     }
/*      */     
/* 1832 */     if ("embeddable".equals(tree.getName())) {
/* 1833 */       AnnotationDescriptor entity = new AnnotationDescriptor(Embeddable.class);
/* 1834 */       return (Embeddable)AnnotationFactory.create(entity);
/*      */     }
/*      */     
/* 1837 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */   private Table getTable(Element tree, XMLContext.Default defaults)
/*      */   {
/* 1843 */     Element subelement = tree == null ? null : tree.element("table");
/* 1844 */     if (subelement == null)
/*      */     {
/* 1846 */       if ((StringHelper.isNotEmpty(defaults.getCatalog())) || (StringHelper.isNotEmpty(defaults.getSchema())))
/*      */       {
/* 1848 */         AnnotationDescriptor annotation = new AnnotationDescriptor(Table.class);
/* 1849 */         if (defaults.canUseJavaAnnotations()) {
/* 1850 */           Table table = (Table)getJavaAnnotation(Table.class);
/* 1851 */           if (table != null) {
/* 1852 */             annotation.setValue("name", table.name());
/* 1853 */             annotation.setValue("schema", table.schema());
/* 1854 */             annotation.setValue("catalog", table.catalog());
/* 1855 */             annotation.setValue("uniqueConstraints", table.uniqueConstraints());
/*      */           }
/*      */         }
/* 1858 */         if ((StringHelper.isEmpty((String)annotation.valueOf("schema"))) && (StringHelper.isNotEmpty(defaults.getSchema())))
/*      */         {
/* 1860 */           annotation.setValue("schema", defaults.getSchema());
/*      */         }
/* 1862 */         if ((StringHelper.isEmpty((String)annotation.valueOf("catalog"))) && (StringHelper.isNotEmpty(defaults.getCatalog())))
/*      */         {
/* 1864 */           annotation.setValue("catalog", defaults.getCatalog());
/*      */         }
/* 1866 */         return (Table)AnnotationFactory.create(annotation);
/*      */       }
/* 1868 */       if (defaults.canUseJavaAnnotations()) {
/* 1869 */         return (Table)getJavaAnnotation(Table.class);
/*      */       }
/*      */       
/* 1872 */       return null;
/*      */     }
/*      */     
/*      */ 
/*      */ 
/* 1877 */     AnnotationDescriptor annotation = new AnnotationDescriptor(Table.class);
/* 1878 */     copyStringAttribute(annotation, subelement, "name", false);
/* 1879 */     copyStringAttribute(annotation, subelement, "catalog", false);
/* 1880 */     if ((StringHelper.isNotEmpty(defaults.getCatalog())) && (StringHelper.isEmpty((String)annotation.valueOf("catalog"))))
/*      */     {
/* 1882 */       annotation.setValue("catalog", defaults.getCatalog());
/*      */     }
/* 1884 */     copyStringAttribute(annotation, subelement, "schema", false);
/* 1885 */     if ((StringHelper.isNotEmpty(defaults.getSchema())) && (StringHelper.isEmpty((String)annotation.valueOf("schema"))))
/*      */     {
/* 1887 */       annotation.setValue("schema", defaults.getSchema());
/*      */     }
/* 1889 */     buildUniqueConstraints(annotation, subelement);
/* 1890 */     return (Table)AnnotationFactory.create(annotation);
/*      */   }
/*      */   
/*      */   private SecondaryTables getSecondaryTables(Element tree, XMLContext.Default defaults)
/*      */   {
/* 1895 */     List<Element> elements = tree == null ? new ArrayList() : tree.elements("secondary-table");
/*      */     
/*      */ 
/* 1898 */     List<SecondaryTable> secondaryTables = new ArrayList(3);
/* 1899 */     for (Element element : elements) {
/* 1900 */       AnnotationDescriptor annotation = new AnnotationDescriptor(SecondaryTable.class);
/* 1901 */       copyStringAttribute(annotation, element, "name", false);
/* 1902 */       copyStringAttribute(annotation, element, "catalog", false);
/* 1903 */       if ((StringHelper.isNotEmpty(defaults.getCatalog())) && (StringHelper.isEmpty((String)annotation.valueOf("catalog"))))
/*      */       {
/* 1905 */         annotation.setValue("catalog", defaults.getCatalog());
/*      */       }
/* 1907 */       copyStringAttribute(annotation, element, "schema", false);
/* 1908 */       if ((StringHelper.isNotEmpty(defaults.getSchema())) && (StringHelper.isEmpty((String)annotation.valueOf("schema"))))
/*      */       {
/* 1910 */         annotation.setValue("schema", defaults.getSchema());
/*      */       }
/* 1912 */       buildUniqueConstraints(annotation, element);
/* 1913 */       annotation.setValue("pkJoinColumns", buildPrimaryKeyJoinColumns(element));
/* 1914 */       secondaryTables.add((SecondaryTable)AnnotationFactory.create(annotation));
/*      */     }
/*      */     
/*      */ 
/*      */ 
/*      */ 
/* 1920 */     if ((secondaryTables.size() == 0) && (defaults.canUseJavaAnnotations())) {
/* 1921 */       SecondaryTable secTableAnn = (SecondaryTable)getJavaAnnotation(SecondaryTable.class);
/* 1922 */       overridesDefaultInSecondaryTable(secTableAnn, defaults, secondaryTables);
/* 1923 */       SecondaryTables secTablesAnn = (SecondaryTables)getJavaAnnotation(SecondaryTables.class);
/* 1924 */       if (secTablesAnn != null) {
/* 1925 */         for (SecondaryTable table : secTablesAnn.value()) {
/* 1926 */           overridesDefaultInSecondaryTable(table, defaults, secondaryTables);
/*      */         }
/*      */       }
/*      */     }
/* 1930 */     if (secondaryTables.size() > 0) {
/* 1931 */       AnnotationDescriptor descriptor = new AnnotationDescriptor(SecondaryTables.class);
/* 1932 */       descriptor.setValue("value", secondaryTables.toArray(new SecondaryTable[secondaryTables.size()]));
/* 1933 */       return (SecondaryTables)AnnotationFactory.create(descriptor);
/*      */     }
/*      */     
/* 1936 */     return null;
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private void overridesDefaultInSecondaryTable(SecondaryTable secTableAnn, XMLContext.Default defaults, List<SecondaryTable> secondaryTables)
/*      */   {
/* 1943 */     if (secTableAnn != null)
/*      */     {
/* 1945 */       if ((StringHelper.isNotEmpty(defaults.getCatalog())) || (StringHelper.isNotEmpty(defaults.getSchema())))
/*      */       {
/* 1947 */         AnnotationDescriptor annotation = new AnnotationDescriptor(SecondaryTable.class);
/* 1948 */         annotation.setValue("name", secTableAnn.name());
/* 1949 */         annotation.setValue("schema", secTableAnn.schema());
/* 1950 */         annotation.setValue("catalog", secTableAnn.catalog());
/* 1951 */         annotation.setValue("uniqueConstraints", secTableAnn.uniqueConstraints());
/* 1952 */         annotation.setValue("pkJoinColumns", secTableAnn.pkJoinColumns());
/* 1953 */         if ((StringHelper.isEmpty((String)annotation.valueOf("schema"))) && (StringHelper.isNotEmpty(defaults.getSchema())))
/*      */         {
/* 1955 */           annotation.setValue("schema", defaults.getSchema());
/*      */         }
/* 1957 */         if ((StringHelper.isEmpty((String)annotation.valueOf("catalog"))) && (StringHelper.isNotEmpty(defaults.getCatalog())))
/*      */         {
/* 1959 */           annotation.setValue("catalog", defaults.getCatalog());
/*      */         }
/* 1961 */         secondaryTables.add((SecondaryTable)AnnotationFactory.create(annotation));
/*      */       }
/*      */       else {
/* 1964 */         secondaryTables.add(secTableAnn);
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */   private static void buildUniqueConstraints(AnnotationDescriptor annotation, Element element) {
/* 1970 */     List uniqueConstraintElementList = element.elements("unique-constraint");
/* 1971 */     UniqueConstraint[] uniqueConstraints = new UniqueConstraint[uniqueConstraintElementList.size()];
/* 1972 */     int ucIndex = 0;
/* 1973 */     Iterator ucIt = uniqueConstraintElementList.listIterator();
/* 1974 */     while (ucIt.hasNext()) {
/* 1975 */       Element subelement = (Element)ucIt.next();
/* 1976 */       List<Element> columnNamesElements = subelement.elements("column-name");
/* 1977 */       String[] columnNames = new String[columnNamesElements.size()];
/* 1978 */       int columnNameIndex = 0;
/* 1979 */       Iterator it = columnNamesElements.listIterator();
/* 1980 */       while (it.hasNext()) {
/* 1981 */         Element columnNameElt = (Element)it.next();
/* 1982 */         columnNames[(columnNameIndex++)] = columnNameElt.getTextTrim();
/*      */       }
/* 1984 */       AnnotationDescriptor ucAnn = new AnnotationDescriptor(UniqueConstraint.class);
/* 1985 */       ucAnn.setValue("columnNames", columnNames);
/* 1986 */       uniqueConstraints[(ucIndex++)] = ((UniqueConstraint)AnnotationFactory.create(ucAnn));
/*      */     }
/* 1988 */     annotation.setValue("uniqueConstraints", uniqueConstraints);
/*      */   }
/*      */   
/*      */   private PrimaryKeyJoinColumn[] buildPrimaryKeyJoinColumns(Element element) {
/* 1992 */     if (element == null) return new PrimaryKeyJoinColumn[0];
/* 1993 */     List pkJoinColumnElementList = element.elements("primary-key-join-column");
/* 1994 */     PrimaryKeyJoinColumn[] pkJoinColumns = new PrimaryKeyJoinColumn[pkJoinColumnElementList.size()];
/* 1995 */     int index = 0;
/* 1996 */     Iterator pkIt = pkJoinColumnElementList.listIterator();
/* 1997 */     while (pkIt.hasNext()) {
/* 1998 */       Element subelement = (Element)pkIt.next();
/* 1999 */       AnnotationDescriptor pkAnn = new AnnotationDescriptor(PrimaryKeyJoinColumn.class);
/* 2000 */       copyStringAttribute(pkAnn, subelement, "name", false);
/* 2001 */       copyStringAttribute(pkAnn, subelement, "referenced-column-name", false);
/* 2002 */       copyStringAttribute(pkAnn, subelement, "column-definition", false);
/* 2003 */       pkJoinColumns[(index++)] = ((PrimaryKeyJoinColumn)AnnotationFactory.create(pkAnn));
/*      */     }
/* 2005 */     return pkJoinColumns;
/*      */   }
/*      */   
/*      */ 
/*      */   private static void copyStringAttribute(AnnotationDescriptor annotation, Element element, String attributeName, boolean mandatory)
/*      */   {
/* 2011 */     String attribute = element.attributeValue(attributeName);
/* 2012 */     if (attribute != null) {
/* 2013 */       String annotationAttributeName = getJavaAttributeNameFromXMLOne(attributeName);
/* 2014 */       annotation.setValue(annotationAttributeName, attribute);
/*      */ 
/*      */     }
/* 2017 */     else if (mandatory) {
/* 2018 */       throw new AnnotationException(element.getName() + "." + attributeName + " is mandatory in XML overring. " + "Activate schema validation for more informations");
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */ 
/*      */   private static void copyIntegerAttribute(AnnotationDescriptor annotation, Element element, String attributeName)
/*      */   {
/* 2026 */     String attribute = element.attributeValue(attributeName);
/* 2027 */     if (attribute != null) {
/* 2028 */       String annotationAttributeName = getJavaAttributeNameFromXMLOne(attributeName);
/* 2029 */       annotation.setValue(annotationAttributeName, attribute);
/*      */       try {
/* 2031 */         int length = Integer.parseInt(attribute);
/* 2032 */         annotation.setValue(annotationAttributeName, Integer.valueOf(length));
/*      */       }
/*      */       catch (NumberFormatException e) {
/* 2035 */         throw new AnnotationException(element.getPath() + attributeName + " not parseable: " + attribute + " (" + "Activate schema validation for more informations" + ")");
/*      */       }
/*      */     }
/*      */   }
/*      */   
/*      */ 
/*      */   private static String getJavaAttributeNameFromXMLOne(String attributeName)
/*      */   {
/* 2043 */     StringBuilder annotationAttributeName = new StringBuilder(attributeName);
/* 2044 */     int index = annotationAttributeName.indexOf("-");
/* 2045 */     while (index != -1) {
/* 2046 */       annotationAttributeName.deleteCharAt(index);
/* 2047 */       annotationAttributeName.setCharAt(index, Character.toUpperCase(annotationAttributeName.charAt(index)));
/*      */       
/*      */ 
/* 2050 */       index = annotationAttributeName.indexOf("-");
/*      */     }
/* 2052 */     return annotationAttributeName.toString();
/*      */   }
/*      */   
/*      */   private static void copyStringElement(Element element, AnnotationDescriptor ad, String annotationAttribute) {
/* 2056 */     String discr = element.getTextTrim();
/* 2057 */     ad.setValue(annotationAttribute, discr);
/*      */   }
/*      */   
/*      */   private static void copyBooleanAttribute(AnnotationDescriptor descriptor, Element element, String attribute) {
/* 2061 */     String attributeValue = element.attributeValue(attribute);
/* 2062 */     if (StringHelper.isNotEmpty(attributeValue)) {
/* 2063 */       String javaAttribute = getJavaAttributeNameFromXMLOne(attribute);
/* 2064 */       descriptor.setValue(javaAttribute, Boolean.valueOf(Boolean.parseBoolean(attributeValue)));
/*      */     }
/*      */   }
/*      */   
/*      */   private <T extends Annotation> T getJavaAnnotation(Class<T> annotationType) {
/* 2069 */     return this.element.getAnnotation(annotationType);
/*      */   }
/*      */   
/*      */   private <T extends Annotation> boolean isJavaAnnotationPresent(Class<T> annotationType) {
/* 2073 */     return this.element.isAnnotationPresent(annotationType);
/*      */   }
/*      */   
/*      */   private Annotation[] getJavaAnnotations() {
/* 2077 */     return this.element.getAnnotations();
/*      */   }
/*      */ }


/* Location:              C:\Users\anandkum\Desktop\source\hibernate-annotations-3.3.1.GA.jar!\org\hibernate\cfg\annotations\reflection\EJB3OverridenAnnotationReader.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */