/*    */ package org.hibernate.cfg.search;
/*    */ 
/*    */ import org.hibernate.event.EventListeners;
/*    */ import org.hibernate.event.PostCollectionRecreateEventListener;
/*    */ import org.hibernate.event.PostCollectionRemoveEventListener;
/*    */ import org.hibernate.event.PostCollectionUpdateEventListener;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class CollectionSearchConfiguration
/*    */ {
/*    */   public static void enableHibernateSearch(EventListeners eventListeners, Object searchEventListener, Class searchEventListenerClass)
/*    */   {
/* 17 */     boolean present = false;
/* 18 */     PostCollectionRecreateEventListener[] listeners = eventListeners.getPostCollectionRecreateEventListeners();
/* 19 */     if (listeners != null) {
/* 20 */       for (Object eventListener : listeners)
/*    */       {
/* 22 */         present = (present) || (searchEventListenerClass == eventListener.getClass());
/*    */       }
/* 24 */       if (!present) {
/* 25 */         int length = listeners.length + 1;
/* 26 */         PostCollectionRecreateEventListener[] newListeners = new PostCollectionRecreateEventListener[length];
/* 27 */         System.arraycopy(listeners, 0, newListeners, 0, length - 1);
/* 28 */         newListeners[(length - 1)] = ((PostCollectionRecreateEventListener)searchEventListener);
/* 29 */         eventListeners.setPostCollectionRecreateEventListeners(newListeners);
/*    */       }
/*    */     }
/*    */     else {
/* 33 */       eventListeners.setPostCollectionRecreateEventListeners(new PostCollectionRecreateEventListener[] { (PostCollectionRecreateEventListener)searchEventListener });
/*    */     }
/*    */     
/*    */ 
/*    */ 
/*    */ 
/* 39 */     boolean present = false;
/* 40 */     PostCollectionRemoveEventListener[] listeners = eventListeners.getPostCollectionRemoveEventListeners();
/* 41 */     if (listeners != null) {
/* 42 */       for (Object eventListener : listeners)
/*    */       {
/* 44 */         present = (present) || (searchEventListenerClass == eventListener.getClass());
/*    */       }
/* 46 */       if (!present) {
/* 47 */         int length = listeners.length + 1;
/* 48 */         PostCollectionRemoveEventListener[] newListeners = new PostCollectionRemoveEventListener[length];
/* 49 */         System.arraycopy(listeners, 0, newListeners, 0, length - 1);
/* 50 */         newListeners[(length - 1)] = ((PostCollectionRemoveEventListener)searchEventListener);
/* 51 */         eventListeners.setPostCollectionRemoveEventListeners(newListeners);
/*    */       }
/*    */     }
/*    */     else {
/* 55 */       eventListeners.setPostCollectionRemoveEventListeners(new PostCollectionRemoveEventListener[] { (PostCollectionRemoveEventListener)searchEventListener });
/*    */     }
/*    */     
/*    */ 
/*    */ 
/*    */ 
/* 61 */     boolean present = false;
/* 62 */     PostCollectionUpdateEventListener[] listeners = eventListeners.getPostCollectionUpdateEventListeners();
/* 63 */     if (listeners != null) {
/* 64 */       for (Object eventListener : listeners)
/*    */       {
/* 66 */         present = (present) || (searchEventListenerClass == eventListener.getClass());
/*    */       }
/* 68 */       if (!present) {
/* 69 */         int length = listeners.length + 1;
/* 70 */         PostCollectionUpdateEventListener[] newListeners = new PostCollectionUpdateEventListener[length];
/* 71 */         System.arraycopy(listeners, 0, newListeners, 0, length - 1);
/* 72 */         newListeners[(length - 1)] = ((PostCollectionUpdateEventListener)searchEventListener);
/* 73 */         eventListeners.setPostCollectionUpdateEventListeners(newListeners);
/*    */       }
/*    */     }
/*    */     else {
/* 77 */       eventListeners.setPostCollectionUpdateEventListeners(new PostCollectionUpdateEventListener[] { (PostCollectionUpdateEventListener)searchEventListener });
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Users\anandkum\Desktop\source\hibernate-annotations-3.3.1.GA.jar!\org\hibernate\cfg\search\CollectionSearchConfiguration.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */