/*    */ package org.hibernate.cfg;
/*    */ 
/*    */ import javax.persistence.JoinTable;
/*    */ import org.hibernate.AssertionFailure;
/*    */ import org.hibernate.annotations.common.reflection.XClass;
/*    */ import org.hibernate.annotations.common.reflection.XProperty;
/*    */ import org.hibernate.mapping.Collection;
/*    */ import org.hibernate.mapping.Join;
/*    */ import org.hibernate.mapping.KeyValue;
/*    */ import org.hibernate.mapping.PersistentClass;
/*    */ import org.hibernate.mapping.Property;
/*    */ import org.hibernate.mapping.Table;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class CollectionPropertyHolder
/*    */   extends AbstractPropertyHolder
/*    */ {
/*    */   Collection collection;
/*    */   
/*    */   public CollectionPropertyHolder(Collection collection, String path, XClass clazzToProcess, XProperty property, PropertyHolder parentPropertyHolder, ExtendedMappings mappings)
/*    */   {
/* 26 */     super(path, parentPropertyHolder, clazzToProcess, mappings);
/* 27 */     this.collection = collection;
/* 28 */     setCurrentProperty(property);
/*    */   }
/*    */   
/*    */   public String getClassName() {
/* 32 */     throw new AssertionFailure("Collection property holder does not have a class name");
/*    */   }
/*    */   
/*    */   public String getEntityOwnerClassName() {
/* 36 */     return null;
/*    */   }
/*    */   
/*    */   public Table getTable() {
/* 40 */     return this.collection.getCollectionTable();
/*    */   }
/*    */   
/*    */   public void addProperty(Property prop) {
/* 44 */     throw new AssertionFailure("Cannot add property to a collection");
/*    */   }
/*    */   
/*    */   public KeyValue getIdentifier() {
/* 48 */     throw new AssertionFailure("Identifier collection not yet managed");
/*    */   }
/*    */   
/*    */   public PersistentClass getPersistentClass() {
/* 52 */     return this.collection.getOwner();
/*    */   }
/*    */   
/*    */   public boolean isComponent() {
/* 56 */     return false;
/*    */   }
/*    */   
/*    */   public boolean isEntity() {
/* 60 */     return false;
/*    */   }
/*    */   
/*    */   public String getEntityName() {
/* 64 */     return this.collection.getOwner().getEntityName();
/*    */   }
/*    */   
/*    */   public void addProperty(Property prop, Ejb3Column[] columns)
/*    */   {
/* 69 */     throw new AssertionFailure("addProperty to a join table of a collection: does it make sense?");
/*    */   }
/*    */   
/*    */   public Join addJoin(JoinTable joinTableAnn, boolean noDelayInPkColumnCreation) {
/* 73 */     throw new AssertionFailure("Add a <join> in a second pass");
/*    */   }
/*    */ }


/* Location:              C:\Users\anandkum\Desktop\source\hibernate-annotations-3.3.1.GA.jar!\org\hibernate\cfg\CollectionPropertyHolder.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */